import j3d.ColoredTriangle3D;
import j3d.Point3D;
import j3d.TexturedTriangle3D;
import j3d.Triangle3D;
import j3d.basic.BasicObject3D;
import j3d.basic.colored.BasicColoredObject3D;
import j3d.basic.textured.BasicTexturedObject3D;

import java.awt.Color;
import java.awt.Point;

public class BuildingO3D extends BasicObject3D
{
	private Object attrib = null;
	private String p;
	private int w,h,d;
	private Color c;

	public BuildingO3D(String path,Color color,int width,int height,int depth) throws Exception
	{
		short[][][] t = TexturedTriangle3D.getTexture(path);
		w = width;
		h = height;
		d = depth;
		c = color;
		p = path;
		vertices = new Point3D[8];
	    alloc(10);
	    
	    float w = width/2, d = depth/2;
	    vertices[0] = new Point3D( w, height, d);
	    vertices[1] = new Point3D( w, 0, d);
	    vertices[2] = new Point3D(-w, 0, d);
	    vertices[3] = new Point3D(-w, height, d);
	    vertices[4] = new Point3D(-w, height,-d);
	    vertices[5] = new Point3D(-w, 0,-d);
	    vertices[6] = new Point3D( w, 0,-d);
	    vertices[7] = new Point3D( w, height,-d);

	    int i = 0;
	    attrib = t;
	    setTriangle(i++,1,2,0);
	    setTriangle(i++,3,0,2);
	    setTriangle(i++,5,6,4);
	    setTriangle(i++,7,4,6);
	    setTriangle(i++,6,1,7);
	    setTriangle(i++,0,7,1);
	    /*
	    setTriangle(i++,6,5,1);
	    setTriangle(i++,2,1,5);
	    */
	    setTriangle(i++,2,5,3);
	    setTriangle(i++,4,3,5);
	    attrib = color;
	    setTriangle(i++,4,7,3);
	    setTriangle(i++,0,3,7);

	    initNormals();
	}

	protected void setTriangle(int idx, int a, int b, int c)
	{
		if (attrib instanceof Color)
		{
			BasicColoredObject3D.setTriangle(this,idx,a,b,c);
			((ColoredTriangle3D)triangles[idx]).setColor((Color)attrib);
		}
		else
		{
			BasicTexturedObject3D.setTriangle(this,idx,a,b,c);
			TexturedTriangle3D t = (TexturedTriangle3D)triangles[idx];
			short[][][] tex = (short[][][])attrib;
			t.texture = tex;
			if ((idx&1)>0)
			{
				t.tp[0] = new Point(0,0);
				t.tp[1] = new Point(tex[0].length-1,0);
				t.tp[2] = new Point(0,tex.length-1);
			}
			else
			{
				t.tp[1] = new Point(0,tex.length-1);
				t.tp[2] = new Point(tex[0].length-1,0);
				t.tp[0] = new Point(tex[0].length-1,tex.length-1);
			}
		}
	}
	
	protected void alloc(int tcount)
	{
		triangles = new Triangle3D[tcount];
	}
	
	
	public String toString()
	{
		return "basic Building "+c.getRed()+" "+c.getGreen()+" "+c.getBlue()+" "+w+" "+h+" "+d+" "+p;
	}
}
