
import j3d.ColoredTriangle3D;
import j3d.DefaultScene3D;
import j3d.DefaultView3D;
import j3d.Light3D;
import j3d.Object3D;
import j3d.Point3D;
import j3d.Position3D;
import j3d.Rotation3D;
import j3d.Scene3D;
import j3d.TexturedTriangle3D;
import j3d.Triangle3D;
import j3d.Vector3D;
import j3d.basic.Track;
import j3d.basic.colored.ColoredBox;
import j3d.basic.colored.ColoredCone;
import j3d.basic.colored.ColoredFractalMap;
import j3d.basic.colored.ColoredTrack;
import j3d.basic.textured.TexturedBox;
import j3d.basic.textured.TexturedMap;
import j3d.basic.textured.TexturedTrack;
import j3d.loader.ASCII3DSObject3DLoader;
import j3d.loader.ASCObject3DLoader;
import j3d.loader.BIN3DSObject3DLoader;
import j3d.loader.DefaultObject3DLoader;
import j3d.loader.LWOObject3DLoader;
import j3d.loader.MD2Object3DLoader;
import j3d.loader.MS3DObject3DLoader;
import j3d.loader.RAWObject3DLoader;
import j3d.loader.RSDObject3DLoader;
import j3d.loader.UNAIObject3DLoader;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.awt.image.BufferedImage;
import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.InputStream;
import java.io.LineNumberReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.Date;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import java.util.zip.GZIPInputStream;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;

import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;

public class Export3D extends JFrame implements ActionListener, MouseListener, MouseMotionListener, TreeSelectionListener, MouseWheelListener
{
	static final long serialVersionUID = 1;

	MonPanel surface;

	public static DefaultScene3D scene;
	public static DefaultView3D view;
	public static Position3D camera;
	public static Point3D plight;
	public static Light3D light;
	public static Light3D[] lights;
	public static Object3D obj;
	public static Rotation3D rot;
	public static DefaultTreeModel tm;
	public static JTree tree;
	public static DefaultMutableTreeNode root, objects, scenes, chars, maps, texts, sprites;

	JPopupMenu objmenu, scenemenu, sprmenu, mapmenu, charmenu, prjmenu,	texmenu;
	JPopupMenu o_menu, sc_menu, sp_menu, m_menu, c_menu, t_menu;
	JPanel cmd, cmdCont;
	JLabel lx, ly, lz;
	JTextField tz;
	int rx, ry, rz;
	int xi, yi;
	Vector<Color> colors = new Vector<Color>();
	Vector textures = new Vector();
	Color curcol = Color.red;
	JButton butColor;

	public Export3D()
	{
		getContentPane().setLayout(new BorderLayout());

		root = new DefaultMutableTreeNode(new ProjectPanel());
		tree = new JTree(tm = new DefaultTreeModel(root));
		tm.insertNodeInto(objects = new DefaultMutableTreeNode("Objects"), root, 0);
		tm.insertNodeInto(sprites = new DefaultMutableTreeNode("Sprites"), root, 1);
		tm.insertNodeInto(scenes = new DefaultMutableTreeNode("Scenes"), root, 2);
		tm.insertNodeInto(chars = new DefaultMutableTreeNode("Characters"),	root, 3);
		tm.insertNodeInto(maps = new DefaultMutableTreeNode("Maps"), root, 4);
		tm.insertNodeInto(texts = new DefaultMutableTreeNode("Textures"), root,	5);
		tree.expandRow(0);
		tree.getSelectionModel().addTreeSelectionListener(this);
		JSplitPane split = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT); 
		getContentPane().add(split,BorderLayout.CENTER);
		split.setLeftComponent(new JScrollPane(tree));
		tree.addMouseListener(this);

		prjmenu = new JPopupMenu();
		JMenuItem mi = new JMenuItem("Load project");
		mi.addActionListener(this);
		mi.setActionCommand("LOAD_PRJ");
		prjmenu.add(mi);
		mi = new JMenuItem("Save project");
		mi.addActionListener(this);
		mi.setActionCommand("SAVE_PRJ");
		prjmenu.add(mi);
		mi = new JMenuItem("New project");
		mi.addActionListener(this);
		mi.setActionCommand("NEW_PRJ");
		prjmenu.add(mi);
		mi = new JMenuItem("Generate C");
		mi.addActionListener(this);
		mi.setActionCommand("GEN_C_PRJ");
		prjmenu.add(mi);
		mi = new JMenuItem("Generate BIN");
		mi.addActionListener(this);
		mi.setActionCommand("GEN_BIN_PRJ");
		prjmenu.add(mi);

		objmenu = new JPopupMenu();
		mi = new JMenuItem("Load object");
		mi.addActionListener(this);
		mi.setActionCommand("LOAD_OBJ");
		objmenu.add(mi);
		mi = new JMenuItem("Add box");
		mi.addActionListener(this);
		mi.setActionCommand("ADD_BOX");
		objmenu.add(mi);
		mi = new JMenuItem("Add textured box");
		mi.addActionListener(this);
		mi.setActionCommand("ADD_TEXTURED_BOX");
		objmenu.add(mi);
		mi = new JMenuItem("Add Cone");
		mi.addActionListener(this);
		mi.setActionCommand("ADD_CONE");
		objmenu.add(mi);
		mi = new JMenuItem("Add sphere");
		mi.addActionListener(this);
		mi.setActionCommand("ADD_SPHERE");
		objmenu.add(mi);
		mi = new JMenuItem("Add map");
		mi.addActionListener(this);
		mi.setActionCommand("ADD_MAP");
		objmenu.add(mi);
		mi = new JMenuItem("Add textured map");
		mi.addActionListener(this);
		mi.setActionCommand("ADD_TEXTURED_MAP");
		objmenu.add(mi);
		mi = new JMenuItem("Add track");
		mi.addActionListener(this);
		mi.setActionCommand("ADD_TRACK");
		objmenu.add(mi);
		mi = new JMenuItem("Add building");
		mi.addActionListener(this);
		mi.setActionCommand("ADD_BUILDING");
		objmenu.add(mi);

		scenemenu = new JPopupMenu();
		mi = new JMenuItem("Add new scene");
		mi.addActionListener(this);
		mi.setActionCommand("NEW_SCENE");
		scenemenu.add(mi);

		sprmenu = new JPopupMenu();
		mi = new JMenuItem("Add new sprite");
		mi.addActionListener(this);
		mi.setActionCommand("NEW_SPRITE");
		sprmenu.add(mi);

		mapmenu = new JPopupMenu();
		mi = new JMenuItem("Add new map");
		mi.addActionListener(this);
		mi.setActionCommand("NEW_MAP");
		mapmenu.add(mi);

		charmenu = new JPopupMenu();
		mi = new JMenuItem("Add new character");
		mi.addActionListener(this);
		mi.setActionCommand("NEW_CHAR");
		charmenu.add(mi);

		texmenu = new JPopupMenu();
		mi = new JMenuItem("Load texture");
		mi.addActionListener(this);
		mi.setActionCommand("LOAD_TEX");
		texmenu.add(mi);

		o_menu = new JPopupMenu();
		mi = new JMenuItem("Remove");
		mi.addActionListener(this);
		mi.setActionCommand("DEL_OBJ");
		o_menu.add(mi);
		mi = new JMenuItem("Yeti");
		mi.addActionListener(this);
		mi.setActionCommand("EXP_YETI");
		o_menu.add(mi);
		mi = new JMenuItem("Smooth");
		mi.addActionListener(this);
		mi.setActionCommand("MD2_SMOOTH");
		o_menu.add(mi);

		sc_menu = new JPopupMenu();
		mi = new JMenuItem("Remove");
		mi.addActionListener(this);
		mi.setActionCommand("DEL_SCENE");
		sc_menu.add(mi);
		mi = new JMenuItem("Add object");
		mi.addActionListener(this);
		mi.setActionCommand("ADD_OBJ");
		sc_menu.add(mi);

		sp_menu = new JPopupMenu();
		mi = new JMenuItem("Remove");
		mi.addActionListener(this);
		mi.setActionCommand("DEL_SPR");
		sp_menu.add(mi);

		m_menu = new JPopupMenu();
		mi = new JMenuItem("Remove");
		mi.addActionListener(this);
		mi.setActionCommand("DEL_MAP");
		m_menu.add(mi);

		c_menu = new JPopupMenu();
		mi = new JMenuItem("Remove");
		mi.addActionListener(this);
		mi.setActionCommand("DEL_CHAR");
		c_menu.add(mi);

		t_menu = new JPopupMenu();
		mi = new JMenuItem("Remove");
		mi.addActionListener(this);
		mi.setActionCommand("DEL_TEX");
		t_menu.add(mi);

		scene = new DefaultScene3D();
		view = new DefaultView3D();

		/*
		 * //ColoredBox box = new ColoredBox(90,120,75,new Color(0,0,255));
		 * ImageIcon img = new ImageIcon("test.gif"); TexturedBox box = new
		 * TexturedBox(90,120,75,img.getImage(),true); scene.addObject(box,new
		 * Position3D(new Point3D(0,0,0),rot = new Rotation3D(0,0,0),1));
		 * setObject(box);
		 */
		lights = new Light3D[1];
		lights[0] = light = new Light3D(plight = new Point3D(800, 800, 800), 0,
				Color.white);
		camera = new Position3D(new Point3D(0, 0, -400), rot = new Rotation3D(
				0, 0, 0), 1f);

		surface = new MonPanel(scene, view, camera, lights,512,512);
		surface.addMouseListener(this);
		surface.addMouseMotionListener(this);
		surface.addMouseWheelListener(this);
		surface.setPreferredSize(new Dimension(640, 480));

		setObject(null);

		JPanel p = new JPanel(new FlowLayout());
		p.add(butColor = new JButton("Color"));
		butColor.setBackground(curcol);
		butColor.setActionCommand("COLOR");
		butColor.addActionListener(this);

		JPanel pp = new JPanel(new BorderLayout());
		pp.add(surface, BorderLayout.CENTER);
		pp.add(p, BorderLayout.NORTH);
		pp.add(cmdCont = new JPanel(new FlowLayout()), BorderLayout.SOUTH);
		cmd = null;
		split.setRightComponent(pp);
		split.setAlignmentX(0.25f);
		pack();

		setVisible(true);

		/*
		 * setObject(loadObject(new File("md2/knight/tris.md2"))); addObject();
		 * scene.removeObject(obj); setObject(loadObject(new
		 * File("md2/knight/weapon.md2"))); addObject();
		 * scene.removeObject(obj); setObject(loadObject(new
		 * File("md2/blade/tris.md2"))); addObject(); scene.removeObject(obj);
		 * setObject(loadObject(new File("md2/cobra/tris.md2"))); addObject();
		 */
	}

	public static String idFromPath(String s)
	{
		s = s.substring(s.lastIndexOf(System.getProperty("file.separator")) + 1);
		int pos = s.indexOf(".");
		return s.substring(0, pos < 0 ? s.length() : pos);
	}

	public static float check(JTextField tf, float v)
	{
		try
		{
			v = Float.valueOf(tf.getText()).floatValue();
		}
		catch (Exception ex)
		{
		}
		tf.setText(String.valueOf(v));
		return v;
	}

	public static void refreshNode()
	{
		TreePath p = tree.getSelectionModel().getLeadSelectionPath();
		tree.getSelectionModel().clearSelection();
		tree.getSelectionModel().setSelectionPath(p);
	}

	private void addObject()
	{
		DefaultMutableTreeNode node = new DefaultMutableTreeNode(new ObjectPanel(obj));
		tm.insertNodeInto(node, objects, tm.getChildCount(objects));
		tree.expandPath(new TreePath(tm.getPathToRoot(objects)));
		Vector v = TexturedTriangle3D.getTextures();
		if (v.size() > tm.getChildCount(texts))
		{
			for (int i = tm.getChildCount(texts); i < v.size(); i++)
			{
				DefaultMutableTreeNode n = new DefaultMutableTreeNode(v.elementAt(i));
				tm.insertNodeInto(n, texts, tm.getChildCount(texts));
			}
		}
		tree.getSelectionModel().setSelectionPath(new TreePath(tm.getPathToRoot(node)));
	}

	public BufferedImage loadTexture(String path)
	{
		try
		{
			BufferedImage bi = TexturedTriangle3D.getImage(path);
			if (bi != null)
			{
				TexturedTriangle3D.getTexture(path, bi); // register texture
				DefaultMutableTreeNode n = new DefaultMutableTreeNode(path);
				tm.insertNodeInto(n, texts, tm.getChildCount(texts));
				return bi;
			}
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		return null;
	}

	public void setObject(Object3D o)
	{
		obj = o;
		surface.obj = o;
	}

	public void actionPerformed(ActionEvent e)
	{
		String ac = e.getActionCommand();
		curmenu = null;
		if (ac.equals("SAVE_PRJ"))
			saveProject();
		else if (ac.equals("LOAD_PRJ"))
			loadProject();
		else if (ac.equals("GEN_C_PRJ"))
			generateC();
		else if (ac.equals("GEN_BIN_PRJ"))
			generateBin();
		else if (ac.equals("EXIT"))
			System.exit(0);
		else if (ac.equals("ADD_BOX"))
		{
			if (obj != null)
				scene.removeObject(obj);
			setObject(new ColoredBox(32, 32, 32, Color.blue));
			addObject();
		}
		else if (ac.equals("ADD_TEXTURED_BOX"))
		{
			if (obj != null)
				scene.removeObject(obj);
			try
			{
				String path = (new File("default.png")).getAbsolutePath();
				setObject(new TexturedBox(64, 64, 64, TexturedTriangle3D.getImage(path), true));
				TexturedTriangle3D.addTexture(path, ((TexturedTriangle3D)obj.getTriangles()[0]).texture);
				addObject();
			}
			catch (Exception ex)
			{
				ex.printStackTrace();
			}
		}
		else if (ac.equals("ADD_CONE"))
		{
			if (obj != null)
				scene.removeObject(obj);
			setObject(new ColoredCone(32, 32, 4, Color.red));
			addObject();
		}
		else if (ac.equals("ADD_SPHERE"))
		{
		}
		else if (ac.equals("ADD_MAP"))
		{
			if (obj != null)
				scene.removeObject(obj);
			DefaultMutableTreeNode node = new DefaultMutableTreeNode(new ObjectPanel("Map", new ColoredFractalMap(32, 32, 2, 32, 64,(int)((new Date()).getTime() % 1000), true,Color.green), 0.1f, false));
			tm.insertNodeInto(node, objects, tm.getChildCount(objects));
		}
		else if (ac.equals("ADD_TEXTURED_MAP"))
		{
			if (obj != null)
				scene.removeObject(obj);
			try
			{
				String path = (new File("default.png")).getAbsolutePath();
				setObject(new TexturedMap(10, 5, TexturedTriangle3D.getImage(path), true));
				TexturedTriangle3D.addTexture(path, ((TexturedTriangle3D)obj.getTriangles()[0]).texture);
				addObject();
			}
			catch (Exception ex)
			{
				ex.printStackTrace();
			}
		}
		else if (ac.equals("ADD_TRACK"))
		{
			if (obj != null)
				scene.removeObject(obj);
			try
			{
/*
				DefaultScene3D scn = new DefaultScene3D(); TexturedTrack tt = new TexturedTrack(128,TexturedTriangle3D.getTexture("road.gif"));
				 scn.addObject(tt,new Position3D());
				 for (int i=0;i<tt.left.length;i++)
				 {
				 	scn.addObject(new ColoredBox(16,16,16,Color.red),new Position3D(new Point3D(tt.left[i].x,tt.left[i].y,tt.left[i].z),new Rotation3D(0,0,0),1));
				 	scn.addObject(new ColoredBox(16,16,16,Color.blue),new Position3D(new Point3D(tt.right[i].x,tt.right[i].y,tt.right[i].z),new Rotation3D(0,0,0),1));
				 }
				 setObject(scn);
*/
				 String path = (new File("road.gif")).getAbsolutePath();
				 setObject(new TexturedTrack(256, path));
			}
			catch (Exception ex)
			{
				setObject(new ColoredTrack(128, Color.white));
			}
			addObject();
		}
		else if (ac.equals("ADD_BUILDING"))
		{
			if (obj != null)
				scene.removeObject(obj);
			try
			{
				String path = (new File("facade.png")).getAbsolutePath();
				setObject(new BuildingO3D(path, new Color(128, 80, 0), 128, 256, 128));
				TexturedTriangle3D.addTexture(path, ((TexturedTriangle3D)obj.getTriangles()[0]).texture);
				addObject();
			}
			catch (Exception ex)
			{
				ex.printStackTrace();
			}
		}
		else if (ac.equals("LOAD_OBJ"))
		{
			JFileChooser fc = new JFileChooser();
			fc.setCurrentDirectory(new File(System.getProperty("user.dir")));
			fc.setMultiSelectionEnabled(true);
			fc.showOpenDialog(this);
			File[] f = fc.getSelectedFiles();
			if (f == null || f.length == 0)
			{
				refresh();
				return;
			}
			for (int i = 0; i < f.length; i++)
			{
				if (obj != null)
					scene.removeObject(obj);
				setObject(loadObject(f[i]));
				if (obj != null)
					addObject();
			}
			if (obj == null)
				refresh();
		}
		else if (ac.equals("NEW_SCENE"))
		{
			DefaultScene3D scn = new DefaultScene3D();
			DefaultMutableTreeNode node = new DefaultMutableTreeNode(new ScenePanel(scn));
			tm.insertNodeInto(node, scenes, tm.getChildCount(scenes));
			tree.getSelectionModel().setSelectionPath(new TreePath(tm.getPathToRoot(node)));
		}
		else if (ac.equals("NEW_SPRITE"))
		{
			Object[] vtn = TexturedTriangle3D.getTexturesNames().toArray();
			SpritePanel sp = new SpritePanel(vtn);
			sp.setName("SPR" + tm.getChildCount(sprites));
			DefaultMutableTreeNode node = new DefaultMutableTreeNode(sp);
			tm.insertNodeInto(node, sprites, tm.getChildCount(sprites));
			tree.getSelectionModel().setSelectionPath(new TreePath(tm.getPathToRoot(node)));
		}
		else if (ac.equals("NEW_MAP"))
		{
			JFileChooser fc = new JFileChooser();
			fc.setCurrentDirectory(new File(System.getProperty("user.dir")));
			fc.showOpenDialog(this);
			File f = fc.getSelectedFile();
			if (f == null)
			{
				refresh();
				return;
			}
			if (obj != null)
				scene.removeObject(obj);
			try
			{
				DefaultMutableTreeNode node = new DefaultMutableTreeNode(LevelMap.loadMap(f));
				tm.insertNodeInto(node, maps, tm.getChildCount(maps));
				tree.getSelectionModel().setSelectionPath(new TreePath(tm.getPathToRoot(node)));
			}
			catch (Exception ex)
			{
				ex.printStackTrace();
			}
		}
		else if (ac.equals("ADD_OBJ"))
		{
			DefaultMutableTreeNode node = (DefaultMutableTreeNode)tree.getSelectionModel().getLeadSelectionPath().getLastPathComponent();
			AddObjectDialog aod = new AddObjectDialog(this, node);
			aod.setVisible(true);
			DefaultMutableTreeNode nd = (DefaultMutableTreeNode)aod.getNode();
			if (nd == null)
				return;
			Object3D o = null;
			ObjectPanel op = (ObjectPanel)nd.getUserObject();
			File f = new File(op.getPath());
			if (f.exists())
				o = loadObject(f);
			else
				o = op.getObject().copy();
			DefaultScene3D scn = (DefaultScene3D)((ScenePanel)node.getUserObject()).getScene();
			Position3D pos = new Position3D(new Point3D(0, 0, 0), new Rotation3D(0, 0, 0), op.getZoom());
			scn.addObject(o, pos);
			DefaultMutableTreeNode n = new DefaultMutableTreeNode(new SubPanel(op, pos));
			tm.insertNodeInto(n, node, tm.getChildCount(node));
			tree.getSelectionModel().setSelectionPath(new TreePath(tm.getPathToRoot(n)));
		}
		else if (ac.equals("LOAD_TEX"))
		{
			JFileChooser fc = new JFileChooser();
			fc.setCurrentDirectory(new File(System.getProperty("user.dir")));
			fc.showOpenDialog(this);
			File f = fc.getSelectedFile();
			if (f == null)
				return;
			loadTexture(f.getAbsolutePath());
		}
		else if (ac.equals("COLOR"))
		{
			Color c = JColorChooser.showDialog(this, "Select color", curcol);
			if (c != null)
				butColor.setBackground(curcol = c);
		}
		else if (ac.equals("EXP_YETI"))
		{
			if (!(obj instanceof MD2Object3DLoader))
				return;
			JFileChooser fc = new JFileChooser();
			fc.setCurrentDirectory(new File(System.getProperty("user.dir")));
			fc.showSaveDialog(this);
			File f = fc.getSelectedFile();
			if (f == null)
			{
				refresh();
				return;
			}
			DefaultMutableTreeNode node = (DefaultMutableTreeNode)tree.getSelectionModel().getLeadSelectionPath().getLastPathComponent();
			ObjectPanel op = (ObjectPanel)node.getUserObject();
			try
			{
				((MD2Object3DLoader)obj).yetiExport(f.getAbsolutePath(), op.getZoom());
			}
			catch (Exception ex)
			{
				ex.printStackTrace();
			}
		}
		else if (ac.equals("MD2_SMOOTH"))
		{
			if (!(obj instanceof MD2Object3DLoader))
				return;
			((MD2Object3DLoader)obj).smoothAnim(1);
		}
		refresh();
	}

	private void saveProject()
	{
		JFileChooser fc = new JFileChooser();
		fc.setCurrentDirectory(new File(System.getProperty("user.dir")));
		fc.showSaveDialog(this);
		File f = fc.getSelectedFile();
		if (f == null)
			return;
		try
		{
			PrintWriter pw = new PrintWriter(new BufferedOutputStream(new FileOutputStream(f)));
			pw.println("[GP32_3D_PROJECT]");
			pw.println(root.getUserObject().toString());
			pw.println("[TEXTURES]");
			int n = tm.getChildCount(texts);
			pw.println(n);
			Vector v = TexturedTriangle3D.getTextures();
			for (int i = 0; i < n; i++)
				pw.println(v.elementAt(i));
			pw.println("[OBJECTS]");
			n = tm.getChildCount(objects);
			pw.println(n);
			for (int i = 0; i < n; i++)
			{
				pw.println("[OBJECT]");
				ObjectPanel p = (ObjectPanel)((DefaultMutableTreeNode)tm.getChild(objects, i)).getUserObject();
				pw.println(p.toString());
				pw.println(p.getPath());
				Object3D o = p.getObject();
				if (o instanceof Track)
				{
					Track tk = (Track)o;
					tk.saveTrack(pw,true);
				}
				pw.println(p.getZoom());
				pw.println(p.isCenter());
				Triangle3D[] t = ((Object3D)(o instanceof Scene3D ? ((Scene3D)o).getObjects()[0] : o)).getTriangles();
				Vector<Integer> vt = new Vector<Integer>();
				for (int j = 0; j < t.length; j++)
				{
					if (t[j] instanceof ColoredTriangle3D)
					{
						ColoredTriangle3D ct = (ColoredTriangle3D)t[j];
						if (ct.isOverloaded())
							vt.addElement(new Integer(j));
					}
				}
				pw.println(vt.size());
				for (int j = 0; j < vt.size(); j++)
				{
					int k = vt.elementAt(j).intValue();
					Color c = ((ColoredTriangle3D)t[k]).getColor();
					pw.println(k + " " + c.getRGB());
				}
			}
			pw.println("[SCENES]");
			n = tm.getChildCount(scenes);
			pw.println(n);
			for (int i = 0; i < n; i++)
			{
				pw.println("[SCENE]");
				DefaultMutableTreeNode sc = (DefaultMutableTreeNode)tm.getChild(scenes, i);
				ScenePanel p = (ScenePanel)sc.getUserObject();
				pw.println(p.toString());
				int m = tm.getChildCount(sc);
				pw.println(m);
				for (int j = 0; j < m; j++)
				{
					pw.println("[SUB]");
					SubPanel sp = (SubPanel)((DefaultMutableTreeNode)tm.getChild(sc, j)).getUserObject();
					pw.println(sp.toString());
					pw.println(sp.pos.pos.x);
					pw.println(sp.pos.pos.y);
					pw.println(sp.pos.pos.z);
					pw.println(sp.pos.rot.x);
					pw.println(sp.pos.rot.y);
					pw.println(sp.pos.rot.z);
				}
			}
			pw.println("[SPRITES]");
			n = tm.getChildCount(sprites);
			pw.println(n);
			for (int i=0;i<n;i++)
			{
				SpritePanel sp = (SpritePanel)((DefaultMutableTreeNode)tm.getChild(sprites, i)).getUserObject();
				Rectangle r = sp.getRectangle();
				pw.println(r.x+" "+r.y+" "+r.width+" "+r.height+" "+sp.getPath());
			}
			pw.println("[MAPS]");
			n = tm.getChildCount(maps);
			pw.println(n);
			pw.println("[CHARACTERS]");
			n = tm.getChildCount(chars);
			pw.println(n);
			pw.close();
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}

	private void loadProject()
	{
		JFileChooser fc = new JFileChooser();
		fc.setCurrentDirectory(new File(System.getProperty("user.dir")));
		fc.showOpenDialog(this);
		File f = fc.getSelectedFile();
		if (f == null)
			return;
		try
		{
			LineNumberReader lnr = new LineNumberReader(new FileReader(f));
			String line = lnr.readLine();
			if (line == null || !line.equals("[GP32_3D_PROJECT]"))
				return;
			((ProjectPanel)root.getUserObject()).setID(lnr.readLine());
			line = lnr.readLine();
			if (line == null || !line.equals("[TEXTURES]"))
				return;
			int n = Integer.valueOf(lnr.readLine()).intValue();
			for (int i = 0; i < n; i++)
			{
				line = lnr.readLine();
				DefaultMutableTreeNode node = new DefaultMutableTreeNode(line);
				tm.insertNodeInto(node, texts, tm.getChildCount(texts));
				TexturedTriangle3D.getTexture(line);
			}
			line = lnr.readLine();
			if (line == null || !line.equals("[OBJECTS]"))
				return;
			n = Integer.valueOf(lnr.readLine()).intValue();
			Hashtable<String,Object> ht = new Hashtable<String,Object>();
			for (int i = 0; i < n; i++)
			{
				lnr.readLine(); // [OBJECT]
				String id = lnr.readLine(); // id
				String path = lnr.readLine();
				Object3D o = null;
				if (path.startsWith("basic "))
				{
					String s = path = path.substring(6);
					int[] v = new int[16];
					int pos = s.indexOf(" ");
					for (int j = 0; j < 16 && pos >= 0; j++)
					{
						s = s.substring(pos + 1);
						pos = s.indexOf(" ");
						try
						{
							v[j] = Integer.valueOf(s.substring(0, pos < 0 ? s.length() : pos)).intValue();
						}
						catch (Exception e)
						{
							break;
						}
					}
					if (path.startsWith("ColoredBox"))
					{
						o = new ColoredBox(v[3], v[4], v[5], new Color(v[0], v[1], v[2]));
					}
					else if (path.startsWith("ColoredCone"))
					{
						o = new ColoredCone(v[3], v[4], v[5], new Color(v[0], v[1], v[2]));
					}
					else if (path.startsWith("ColoredFractalMap"))
					{
						o = new ColoredFractalMap(v[3], v[4], v[5], v[6], v[7], v[8], v[9] == 1, new Color(v[0], v[1], v[2]));
					}
					else if (path.startsWith("TexturedMap"))
					{
						String p = (new File("default.png")).getAbsolutePath();
						o = new TexturedMap(10, 5, TexturedTriangle3D.getImage(p), true);
					}
					else if (path.startsWith("TexturedBox"))
					{
						String p = (new File("facade.png")).getAbsolutePath();
						o = new TexturedBox(v[0], v[1], v[2], TexturedTriangle3D.getImage(p), true);
						TexturedTriangle3D.setTexturePath(p,((TexturedTriangle3D)o.getTriangles()[0]).getTexture());
					}
					else if (path.startsWith("TexturedTrack"))
					{
						o = new TexturedTrack(v[0], s, lnr);
						TexturedTriangle3D.addTexture(s, ((TexturedTriangle3D)o.getTriangles()[0]).texture);
					}
					else if (path.startsWith("Building"))
					{
						o = new BuildingO3D(s, new Color(v[0], v[1], v[2]), v[3], v[4], v[5]);
						TexturedTriangle3D.addTexture(s, ((TexturedTriangle3D)o.getTriangles()[0]).texture);
					}
				}
				else
					o = loadObject(new File(path));
				float z = Float.valueOf(lnr.readLine()).floatValue(); // zoom
				boolean center = Boolean.valueOf(lnr.readLine()).booleanValue(); // zoom
				int l = Integer.valueOf(lnr.readLine()).intValue();
				Triangle3D[] tris = o.getTriangles();
				for (int j = 0; j < l; j++)
				{
					line = lnr.readLine();
					int pos = line.indexOf(' ');
					int k = Integer.valueOf(line.substring(0, pos)).intValue();
					Color c = new Color(Integer.valueOf(line.substring(pos + 1)).intValue());
					((ColoredTriangle3D)tris[k]).overloadColor(c);
				}
				ObjectPanel op = new ObjectPanel(id, o, z, center);
				ht.put(line, op);
				DefaultMutableTreeNode node = new DefaultMutableTreeNode(op);
				tm.insertNodeInto(node, objects, tm.getChildCount(objects));
			}
			line = lnr.readLine();
			if (line == null || !line.equals("[SCENES]"))
				return;
			n = Integer.valueOf(lnr.readLine()).intValue();
			for (int i = 0; i < n; i++)
			{
				lnr.readLine(); // [SCENE]
				line = lnr.readLine(); // id
				int m = Integer.valueOf(lnr.readLine()).intValue();
				DefaultScene3D scn = new DefaultScene3D();
				DefaultMutableTreeNode node = new DefaultMutableTreeNode(new ScenePanel(line,scn));
				tm.insertNodeInto(node, scenes, tm.getChildCount(scenes));
				for (int j = 0; j < m; j++)
				{
					lnr.readLine(); // [SUB]
					line = lnr.readLine(); // id
					ObjectPanel op = (ObjectPanel)ht.get(line);
					Object3D o = loadObject(new File(op.getPath()));
					Position3D pos = new Position3D(new Point3D(0, 0, 0),new Rotation3D(0, 0, 0), op.getZoom());
					pos.pos.x = Float.valueOf(lnr.readLine()).floatValue();
					pos.pos.y = Float.valueOf(lnr.readLine()).floatValue();
					pos.pos.z = Float.valueOf(lnr.readLine()).floatValue();
					pos.rot.x = Float.valueOf(lnr.readLine()).floatValue();
					pos.rot.y = Float.valueOf(lnr.readLine()).floatValue();
					pos.rot.z = Float.valueOf(lnr.readLine()).floatValue();
					scn.addObject(o, pos);
					DefaultMutableTreeNode nd = new DefaultMutableTreeNode(new SubPanel(op, pos));
					tm.insertNodeInto(nd, node, tm.getChildCount(node));
				}
			}
			line = lnr.readLine();
			if (line == null || !line.equals("[SPRITES]"))
				return;
			n = Integer.valueOf(lnr.readLine()).intValue();
			Object[] vtn = TexturedTriangle3D.getTexturesNames().toArray();
			for (int i = 0; i < n; i++)
			{
				String s = lnr.readLine();
				int[] v = new int[4];
				int pos = s.indexOf(" ");
				for (int j = 0; j < 4 && pos >= 0; j++)
				{
					v[j] = Integer.valueOf(s.substring(0, pos < 0 ? s.length() : pos)).intValue();
					s = s.substring(pos + 1);
					pos = s.indexOf(" ");
				}
				s = s.substring(pos + 1);
				SpritePanel sp = new SpritePanel(vtn, s, v[0], v[1], v[2], v[3]);
				sp.setName("SPR" + tm.getChildCount(sprites));
				DefaultMutableTreeNode node = new DefaultMutableTreeNode(sp);
				tm.insertNodeInto(node, sprites, tm.getChildCount(sprites));
			}
			lnr.close();
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}

	private static File ungzipToTemp(File zip) throws Exception
	{
		GZIPInputStream zis = new GZIPInputStream(new FileInputStream(zip));
		File tempdir = new File("temp");
		if (!tempdir.exists())
			tempdir.mkdir();
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		int r;
		byte[] buf = new byte[8192];
		while ((r = zis.read(buf)) != -1)
			baos.write(buf, 0, r);
		String name = zip.getName();
		name = name.substring(0, name.length() - 3);
		File f = new File(tempdir, name);
		FileOutputStream fos = new FileOutputStream(f);
		fos.write(baos.toByteArray());
		fos.close();
		return f;
	}

	private static File unzipToTemp(File zip) throws Exception
	{
		ZipFile zf = new ZipFile(zip);
		File tempdir = new File("temp");
		if (!tempdir.exists())
			tempdir.mkdir();
		File ret = null;
		String exts = ".RAW.OBJ.3DS.LWO.MD2.RSD.ASC.ASE.3DF.MS3D";
		for (Enumeration en = zf.entries(); en.hasMoreElements();)
		{
			ZipEntry ze = (ZipEntry) en.nextElement();
			String n = ze.getName();
			File f = new File(tempdir, n);
			if (n.length() > 4 && exts.indexOf(f.getName().substring(f.getName().lastIndexOf('.')).toUpperCase()) >= 0)
				ret = f;
			FileOutputStream fos = new FileOutputStream(f);
			InputStream zis = zf.getInputStream(ze);
			byte[] buf = new byte[(int)ze.getSize()];
			int o = 0, r;
			while (o < buf.length)
			{
				r = zis.read(buf, o, buf.length - o);
				if (r >= 0)
					o += r;
			}
			fos.write(buf);
			fos.close();
			zis.close();
		}
		return ret;
	}

	private static void deleteTemp() throws Exception
	{
		File tempdir = new File("temp");
		if (!tempdir.exists() || !tempdir.isDirectory())
			return;
		String[] l = tempdir.list();
		for (int i = 0; l != null && i < l.length; i++)
			(new File(tempdir, l[i])).delete();
		tempdir.delete();
	}

	public static Object3D loadObject(File f)
	{
		Object3D o = null;
		try
		{
			String up = f.getName().toUpperCase();
			if (up.endsWith(".ZIP"))
			{
				f = unzipToTemp(f);
				if (f == null)
					return o;
				up = f.getName().toUpperCase();
			}
			else if (up.endsWith(".GZ"))
			{
				f = ungzipToTemp(f);
				if (f == null)
					return o;
				up = f.getName().toUpperCase();
			}
			if (up.endsWith(".RAW"))
				o = (new RAWObject3DLoader()).loadObject(f);
			else if (up.endsWith(".OBJ"))
				o = (new DefaultObject3DLoader()).loadObject(f);
			else if (up.endsWith(".RSD"))
				o = (new RSDObject3DLoader()).loadObject(f);
			else if (up.endsWith(".ASE"))
				o = (new ASCII3DSObject3DLoader()).loadObject(f);
			else if (up.endsWith(".ASC"))
				o = (new ASCObject3DLoader()).loadObject(f);
			else if (up.endsWith(".MD2"))
				o = (new MD2Object3DLoader()).loadObject(f);
			else if (up.endsWith(".3DS"))
				o = (new BIN3DSObject3DLoader()).loadObject(f);
			else if (up.endsWith(".LWO"))
				o = (new LWOObject3DLoader()).loadObject(f);
			else if (up.endsWith(".3DF"))
				o = (new UNAIObject3DLoader()).loadObject(f);
			else if (up.endsWith(".MS3D"))
				o = (new MS3DObject3DLoader()).loadObject(f);
			deleteTemp();
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		return o;
	}

	public static int gpcol(int c)
	{
		if ((c < 0xf8) && (c & 0x7) > 3)
			c += 8;
		return (c & 0xf8) >> 3;
	}

	public static int GPCOL(Color c)
	{
		return (gpcol(c.getRed()) << 11) + (gpcol(c.getGreen()) << 6) + (gpcol(c.getBlue()) << 1);
	}

	public void generateC()
	{
		try
		{
			String pid = root.getUserObject().toString();
			PrintWriter pw0 = new PrintWriter(new BufferedOutputStream(new FileOutputStream(pid + ".h")));
			pw0.println("#ifndef _" + pid.toUpperCase() + "_H_");
			pw0.println("#define _" + pid.toUpperCase() + "_H_");
			pw0.println();
			pw0.println("#include \"o3d.h\"");
			pw0.println();

			for (int i = 0; i < tm.getChildCount(objects); i++)
			{
				colors.removeAllElements();
				ObjectPanel op = (ObjectPanel)((DefaultMutableTreeNode)tm.getChild(objects, i)).getUserObject();
				String id = pid + "_" + op.toString(), uid = id.toUpperCase();
				PrintWriter pw = new PrintWriter(new BufferedOutputStream(new FileOutputStream(id + ".c")));

				Object3D obj = op.getObject();
				if (obj instanceof Scene3D)
				{
					Object[] o = ((Scene3D)obj).getObjects();
					for (int j = 0; j < o.length; j++)
						saveObjectAsC((Object3D)o[j], pid, o.length == 1 ? id : id + "_" + j, pw, op.getZoom(), true, true);
					if (o.length == 1)
					{
						pw0.println("#define " + uid + "_TYPE OBJECT");
						pw0.println("extern OBJECT3D " + id + ";");
					}
					else
					{
						pw0.println("#define " + uid + "_TYPE SCENE");
						pw0.println();
						for (int j = 0; j < o.length; j++)
							pw0.println("extern OBJECT3D " + id + "_" + j + ";");
						pw0.println();
						pw0.println("SCENE3D " + id + " = {");
						pw0.println(o.length + ",");
						pw0.println("{");
						for (int j = 0; j < o.length; j++)
							pw0.println("{OBJECT,{&"
											+ id
											+ "_"
											+ j
											+ "},{0,0,0},{0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},0}"
											+ (j + 1 < o.length ? "," : ""));
						pw0.println("}};");
					}
					pw0.println();
				}
				else if (obj instanceof MD2Object3DLoader)
				{
					pw0.println("#define " + uid + "_TYPE ANIMATION");
					pw0.println();

					MD2Object3DLoader anim = (MD2Object3DLoader)obj;

					Vector<String> v = new Vector<String>(anim.getNames());
					anim.disableExport(-1);
					String[][] keep = {
							{ "stand", "idle" },
							{ "run", "walk", "fly" }, { "attack", "melee" },
							{ "shootattack" }, { "pain" },
							{ "death", "deatha" }, { "crstand", "crstnd" },
							{ "crwalk" }, { "crattack", "crattak" },
							{ "crpain" }, { "crdeath", "cdeth" }, { "jump" },
							{ "resting", "Frame " } };
					Vector<String> vk = new Vector<String>();
					for (int j = 0; j < keep.length; j++)
					{
						int k;
						for (k = 0; k < keep[j].length; k++)
						{
							int pos = v.indexOf(keep[j][k]);
							if (pos >= 0)
							{
								vk.addElement(keep[j][k]);
								anim.enableExport(pos);
								break;
							}
						}
					}

					for (int j = 0; j < vk.size(); j++)
					{
						String s = (String)vk.elementAt(j);
						pw0.println("#define " + uid + "_" + s.toUpperCase() + "_START " + anim.exportIndex(s));
						pw0.println("#define " + uid + "_" + s.toUpperCase() + "_END   " + anim.exportIndexEnd(s));
					}
					pw0.println();
					anim.setFrame(0);
					int nbf = anim.exportFrameCount();
					for (int j = 0; j < nbf; j++)
					{
						saveObjectAsC(anim.getFrame(), pid, id + "_" + j, pw, op.getZoom(), j == 0, false);
						anim.nextFrame();
					}

					pw0.println("#define " + uid + "_NBF " + nbf);
					pw0.println();

					pw.println();
					pw.println("#define " + uid + "_NBF " + nbf);
					pw.println();

					pw.println("const OBJECT3D* " + id + "_obj[" + uid + "_NBF" + "] = {");
					for (int j = 0; j < nbf; j++)
						pw.println("&" + id + "_" + j + (j + 1 == nbf ? "" : ","));
					pw.println("};");

					pw0.println("extern OBJECT3D* " + id + "_obj[" + uid + "_NBF" + "];");
					pw0.println();
				}
				else
				{
					pw0.println("#define " + uid + "_TYPE OBJECT");
					pw0.println("extern OBJECT3D " + id + ";");
					pw0.println();
					saveObjectAsC(obj, pid, id, pw, op.getZoom(), true, true);
				}
				pw.close();
			}
			pw0.println("#endif");
			pw0.close();
			if (tm.getChildCount(texts) > 0)
				saveTexturesAsC(pid);
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}

	private static final int TEXSIZE = 256;

	public int txTrans(int x, int l)
	{
		return (l < TEXSIZE) ? x : (x * TEXSIZE) / l;
	}

	public int txUntrans(int x, int l)
	{
		return (l < TEXSIZE) ? x : (x * l) / TEXSIZE;
	}

	public void saveObjectAsC(Object3D obj, String pid, String id,PrintWriter pw, float zoom, boolean saveT, boolean saveVN) throws Exception
	{
		String uid = id.toUpperCase();

		if (saveT)
		{
			pw.println("#include \"o3d.h\"");
			pw.println();
			if (tm.getChildCount(texts) > 0)
			{
				pw.println("#include \"" + pid + "_tex.h\"");
				pw.println();
			}
		}

		Triangle3D[] t = obj.getTriangles();
		for (int i = 0; saveT && i < t.length; i++)
		{
			if ((t[i] instanceof ColoredTriangle3D))
			{
				Color c = ((ColoredTriangle3D)t[i]).getColor();
				if (colors.contains(c))
					continue;
				pw.println("const COLOR3D " + id + "_col_" + colors.size()+ " = {" + c.getRed() + "," + c.getGreen() + ","+ c.getBlue() + "};");
				pw.println();
				colors.addElement(c);
			}
			else
			{
				TexturedTriangle3D tt = (TexturedTriangle3D)t[i];
				short[][][] tx = tt.getTexture();
				int j = TexturedTriangle3D.getTextureIndex(tx);
				int w = tx[0].length;
				int h = tx.length;
				pw.println("const TEXTURE3D_DATA " + id + "_td_" + i + " = {{"
						+ txTrans(tt.tp[0].x, w) + "," + txTrans(tt.tp[1].x, w)	+ "," + txTrans(tt.tp[2].x, w) + "},{"
						+ txTrans(tt.tp[0].y, h) + "," + txTrans(tt.tp[1].y, h)	+ "," + txTrans(tt.tp[2].y, h) + "},&" + pid + "_tex_" + j + "};");
				pw.println();
			}
		}
		Point3D[] v = obj.getVertices();
		pw.println("#define " + uid + "_NBV " + v.length);
		pw.println();
		pw.println("SVERTEX3D " + id + "_v[" + uid + "_NBV] = {");
		int maxx = Integer.MIN_VALUE;
		int maxy = Integer.MIN_VALUE;
		int maxz = Integer.MIN_VALUE;
		int minx = Integer.MAX_VALUE;
		int miny = Integer.MAX_VALUE;
		int minz = Integer.MAX_VALUE;
		for (int i = 0; i < v.length; i++)
		{
			int x = (int)(v[i].x * zoom), y = (int)(v[i].y * zoom), z = (int)(v[i].z * zoom);
			maxx = x > maxx ? x : maxx;
			maxy = y > maxy ? y : maxy;
			maxz = z > maxz ? z : maxz;
			minx = x < minx ? x : minx;
			miny = y < miny ? y : miny;
			minz = z < minz ? z : minz;
			pw.println("{" + x + "," + y + "," + z + "}" + (i + 1 < v.length ? "," : ""));
		}
		pw.println("};");
		pw.println();

		pw.println("const SVERTEX3D " + id + "_bb[8] = {");
		pw.println("{" + minx + "," + maxy + "," + maxz + "},{" + maxx + "," + maxy + "," + maxz + "},{" + maxx + "," + miny + "," + maxz + "},{" + minx + "," + miny + "," + maxz + "},");
		pw.println("{" + minx + "," + maxy + "," + minz + "},{" + maxx + "," + maxy + "," + minz + "},{" + maxx + "," + miny + "," + minz + "},{" + minx + "," + miny + "," + minz + "}");
		pw.println("};");
		pw.println();

		if (saveVN)
		{
			pw.println("const SVECTOR3D " + id + "_vn[" + uid + "_NBV] = {");
			Vector3D[] vn = obj.getVNormals();
			for (int i = 0; i < vn.length; i++)
			{
				vn[i].normalize();
				pw.println("{" 	+ ((int)(vn[i].x * Tables.MULT)) + ","
								+ ((int)(vn[i].y * Tables.MULT)) + ","
								+ ((int)(vn[i].z * Tables.MULT)) + "}"
								+ (i + 1 < vn.length ? "," : ""));
			}
			pw.println("};");
		}
		else
			pw.println("#define " + id + "_vn NULL");
		pw.println();

		pw.println("#define " + uid + "_NBT " + t.length);
		pw.println();

		if (saveT)
		{
			pw.println("const TRIANGLE3D " + id + "_t[" + uid + "_NBT] = {");
			for (int i = 0; i < t.length; i++)
			{
				pw.print("{" + t[i].a + "," + t[i].b + "," + t[i].c + ",");
				if (t[i] instanceof ColoredTriangle3D)
					pw.print("COLORED,{&"
							+ id
							+ "_col_"
							+ colors.indexOf(((ColoredTriangle3D)t[i]).getColor()) + "}");
				else
					pw.print("TEXTURED,{&" + id + "_td_" + i + "}");
				pw.println("}" + (i + 1 < t.length ? "," : ""));
			}
			pw.println("};");
			pw.println();
		}

		Vector3D[] tn = obj.getTNormals();
		pw.println("const SVECTOR3D " + id + "_tn[" + uid + "_NBT] = {");
		for (int i = 0; i < tn.length; i++)
		{
			tn[i].normalize();
			pw.println("{" + ((int)(tn[i].x * Tables.MULT)) + ","
					+ ((int)(tn[i].y * Tables.MULT)) + ","
					+ ((int)(tn[i].z * Tables.MULT)) + "}"
					+ (i + 1 < tn.length ? "," : ""));
		}
		pw.println("};");
		pw.println();

		pw.println("OBJECT3D " + id + " =");
		pw.println("{");
		pw.println(uid + "_NBV,");
		pw.println(id + "_v,");
		pw.println(id + "_vn,");
		pw.println(uid + "_NBT,");
		if (saveT)
			pw.println(id + "_t,");
		else
			pw.println(id.substring(0, id.lastIndexOf("_") + 1) + "0_t,");
		pw.println(id + "_tn,");
		pw.println(id + "_bb,");
		pw.println("0,");
		pw.println("NULL");
		pw.println("};");
		pw.println();
	}

	private void saveTexturesAsC(String pid) throws Exception
	{
		PrintWriter pw = new PrintWriter(new BufferedOutputStream(new FileOutputStream(pid + "_tex.h")));
		pw.println("#include \"o3d.h\"");
		pw.println();
		pw.println("#ifndef _" + pid.toUpperCase() + "_TEX_H_");
		pw.println("#define _" + pid.toUpperCase() + "_TEX_H_");
		pw.println();
		for (int i = 0; i < tm.getChildCount(texts); i++)
		{
			pw.println("extern TEXTURE3D " + pid + "_tex_" + i + ";");
			pw.println();
		}
		pw.println("#endif");
		pw.println();
		pw.close();
		pw = new PrintWriter(new BufferedOutputStream(new FileOutputStream(pid+ "_tex.c")));
		pw.println("#include \"o3d.h\"");
		pw.println();
		for (int i = 0; i < tm.getChildCount(texts); i++)
		{
			Vector<Color> pal = new Vector<Color>();
			short[][][] tx = TexturedTriangle3D.getTexture(((DefaultMutableTreeNode)tm.getChild(texts, i)).getUserObject().toString());
			int[][] pix = new int[txTrans(tx.length, tx.length)][txTrans(tx[0].length, tx[0].length)];
			int trans = 255;
			int rsum = 0, gsum = 0, bsum = 0;
			for (int a = 0; a < pix.length; a++)
			{
				int aa = txUntrans(a, tx.length);
				for (int b = 0; b < pix[0].length; b++)
				{
					int bb = txUntrans(b, tx[0].length);
					rsum += tx[aa][bb][0];
					gsum += tx[aa][bb][1];
					bsum += tx[aa][bb][2];
					Color cc = new Color(tx[aa][bb][0], tx[aa][bb][1],tx[aa][bb][2]);
					int pos = pal.indexOf(cc);
					if (pos < 0)
					{
						pos = pal.size();
						pal.addElement(cc);
						if (tx[aa][bb][0] == tx[aa][bb][2] && tx[aa][bb][0] - tx[aa][bb][1] >= 224)
							trans = pos;
					}
					pix[a][b] = pos;
				}
			}
			rsum /= pix.length * pix[0].length;
			gsum /= pix.length * pix[0].length;
			bsum /= pix.length * pix[0].length;
			pw.println("const COLOR3D " + pid + "_pal_" + i + "[" + pal.size() + "] = {");
			for (int a = 0; a < pal.size(); a++)
			{
				Color cc = pal.elementAt(a);
				pw.print("{" + cc.getRed() + "," + cc.getGreen() + "," + cc.getBlue() + "}" + (a + 1 < pal.size() ? "," : ""));
				if (((a + 1) % 16) == 0)
					pw.println();
			}
			pw.println("};");
			pw.println();
			pw.println("const unsigned short " + pid + "_gpal_" + i + "[" + pal.size() + "] = {");
			for (int a = 0; a < pal.size(); a++)
			{
				Color cc = ((Color)pal.elementAt(a));
				pw.print(GPCOL(cc) + (a + 1 < pal.size() ? "," : ""));
				if (((a + 1) % 16) == 0)
					pw.println();
			}
			pw.println("};");
			pw.println();
			pw.println("const unsigned char " + pid + "_pix_" + i + "[" + (pix.length * pix[0].length) + "] = {");
			for (int a = 0; a < pix.length; a++)
			{
				for (int b = 0; b < pix[0].length; b++)
					pw.print(pix[a][b]+ (((a + 1 < pix.length) || (b + 1 < pix[0].length)) ? "," : ""));
				pw.println();
			}
			pw.println("};");
			pw.println();
			pw.println("const TEXTURE3D " + pid + "_tex_" + i + " = {"
						+ (pix[0].length - 1) + "," + (pix.length - 1) + ","
						+ (pal.size() - 1) + "," + pid + "_pal_" + i + "," + pid
						+ "_gpal_" + i + "," + pid + "_pix_" + i + "," + trans
						+ ",{" + rsum + "," + gsum + "," + bsum + "}};");
			pw.println();
		}
		pw.close();
	}

	public static void write8(OutputStream os, int data) throws Exception
	{
		os.write(data & 0xff);
	}

	public static void write16(OutputStream os, int data) throws Exception
	{
		write8(os, data >> 8);
		write8(os, data);
	}

	public void generateBin()
	{
		try
		{
			String pid = root.getUserObject().toString();

			for (int i = 0; i < tm.getChildCount(objects); i++)
			{
				colors.removeAllElements();
				ObjectPanel op = (ObjectPanel)((DefaultMutableTreeNode)tm.getChild(objects, i)).getUserObject();
				String id = pid + "_" + op.toString();
				OutputStream os = new BufferedOutputStream(new FileOutputStream(id + ".o3d"));

				Object3D obj = op.getObject();
				while (obj instanceof Scene3D && ((Scene3D)obj).getObjects().length == 1)
					obj = (Object3D)((Scene3D)obj).getObjects()[0];
				if (obj instanceof Scene3D)
				{
					Object[] o = ((Scene3D)obj).getObjects();
					write8(os, 0); // scene
					write8(os, o.length);
					// TODO : position of each object in scene
					for (int j = 0; j < o.length; j++)
						saveObjectAsBin((Object3D)o[j], os, op.getZoom(), true, true);
				}
				else if (obj instanceof MD2Object3DLoader)
				{
					write8(os, 1); // animation
					MD2Object3DLoader anim = (MD2Object3DLoader)obj;
					Vector<String> v = new Vector<String>(anim.getNames());
					anim.disableExport(-1);
					String[][] keep = {
							{ "stand", "idle" },
							{ "run", "walk", "fly" }, { "attack", "melee" },
							{ "shootattack" }, { "pain" },
							{ "death", "deatha" }, { "crstand", "crstnd" },
							{ "crwalk" }, { "crattack", "crattak" },
							{ "crpain" }, { "crdeath", "cdeth" }, { "jump" },
							{ "resting", "Frame " } };
					Vector<String> vk = new Vector<String>();
					for (int j = 0; j < keep.length; j++)
					{
						int k;
						for (k = 0; k < keep[j].length; k++)
						{
							int pos = v.indexOf(keep[j][k]);
							if (pos >= 0)
							{
								vk.addElement(keep[j][k]);
								anim.enableExport(pos);
								break;
							}
						}
					}
					write8(os, vk.size()); // anim count
					for (int j = 0; j < vk.size(); j++)
					{
						String s = vk.elementAt(j);
						write16(os, anim.exportIndex(s)); // anim start
						write16(os, anim.exportIndexEnd(s)); // anim end
					}

					anim.setFrame(0);
					int nbf = anim.exportFrameCount();
					write16(os, nbf); // frames count
					for (int j = 0; j < nbf; j++)
					{
						saveObjectAsBin(anim.getFrame(), os, op.getZoom(), j == 0, false);
						anim.nextFrame();
					}
				}
				else
				{
					write8(os, 2); // single object
					saveObjectAsBin(obj, os, op.getZoom(), true, true);
				}
				os.close();
			}
			if (tm.getChildCount(texts) > 0)
				saveTexturesAsBin(pid);
			if (tm.getChildCount(sprites) > 0)
				saveSpritesAsBin(pid);
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}

	public int getTextureIndex(int idx)
	{
		return getTextureIndex(TexturedTriangle3D.getTextures().elementAt(idx).toString());
	}

	public int getTextureIndex(String tname)
	{
		for (int i = 0; i < tm.getChildCount(texts); i++)
		{
			if (tname.equalsIgnoreCase(((DefaultMutableTreeNode)tm.getChild(texts, i)).getUserObject().toString()))
				return i;
		}
		return -1;
	}

	public void saveObjectAsBin(Object3D obj, OutputStream os, float zoom, boolean saveT, boolean saveVN) throws Exception
	{
		Triangle3D[] t = obj.getTriangles();
		for (int i = 0; i < t.length; i++)
		{
			if ((t[i] instanceof ColoredTriangle3D))
			{
				Color c = ((ColoredTriangle3D)t[i]).getColor();
				if (!colors.contains(c))
					colors.addElement(c);
			}
		}

		// colors list
		if (saveT)
		{
			write16(os, colors.size());
			for (int i = 0; i < colors.size(); i++)
			{
				Color c = (Color)colors.elementAt(i);
				write8(os, c.getRed());
				write8(os, c.getGreen());
				write8(os, c.getBlue());
			}
		}

		// vertices list
		Point3D[] v = obj.getVertices();
		write16(os, v.length);
		int maxx = Integer.MIN_VALUE;
		int maxy = Integer.MIN_VALUE;
		int maxz = Integer.MIN_VALUE;
		int minx = Integer.MAX_VALUE;
		int miny = Integer.MAX_VALUE;
		int minz = Integer.MAX_VALUE;
		for (int i = 0; i < v.length; i++)
		{
			int x = (int)(v[i].x * zoom), y = (int)(v[i].y * zoom), z = (int)(v[i].z * zoom);
			maxx = x > maxx ? x : maxx;
			maxy = y > maxy ? y : maxy;
			maxz = z > maxz ? z : maxz;
			minx = x < minx ? x : minx;
			miny = y < miny ? y : miny;
			minz = z < minz ? z : minz;
			write16(os, x);
			write16(os, y);
			write16(os, z);
		}

		//  bounding box
		write16(os, minx);
		write16(os, maxy);
		write16(os, maxz);
		write16(os, maxx);
		write16(os, maxy);
		write16(os, maxz);
		write16(os, maxx);
		write16(os, miny);
		write16(os, maxz);
		write16(os, minx);
		write16(os, miny);
		write16(os, maxz);
		write16(os, minx);
		write16(os, maxy);
		write16(os, minz);
		write16(os, maxx);
		write16(os, maxy);
		write16(os, minz);
		write16(os, maxx);
		write16(os, miny);
		write16(os, minz);
		write16(os, minx);
		write16(os, miny);
		write16(os, minz);

		// Vertex normals
		if (saveVN)
		{
			Vector3D[] vn = obj.getVNormals();
			write16(os, vn.length);
			for (int i = 0; i < vn.length; i++)
			{
				vn[i].normalize();
				write16(os, (int)(vn[i].x * Tables.MULT));
				write16(os, (int)(vn[i].y * Tables.MULT));
				write16(os, (int)(vn[i].z * Tables.MULT));
			}
		}
		else
			write16(os, 0);

		if (saveT)
		{
			write16(os, t.length);

			for (int i = 0; i < t.length; i++)
			{
				write16(os, t[i].a);
				write16(os, t[i].b);
				write16(os, t[i].c);
				if (t[i] instanceof ColoredTriangle3D)
				{
					write16(os, colors.indexOf(((ColoredTriangle3D)t[i]).getColor()));
				}
				else
				{
					TexturedTriangle3D tt = (TexturedTriangle3D)t[i];
					short[][][] tx = tt.getTexture();
					int j = getTextureIndex(TexturedTriangle3D.getTextureIndex(tx));
					int w = tx[0].length;
					int h = tx.length;
					write16(os, 0x8000 + j);
					write8(os, txTrans(tt.tp[0].x, w));
					write8(os, txTrans(tt.tp[1].x, w));
					write8(os, txTrans(tt.tp[2].x, w));
					write8(os, txTrans(tt.tp[0].y, h));
					write8(os, txTrans(tt.tp[1].y, h));
					write8(os, txTrans(tt.tp[2].y, h));
				}
			}
		}

		Vector3D[] tn = obj.getTNormals();
		write16(os, t.length);
		for (int i = 0; i < tn.length; i++)
		{
			tn[i].normalize();
			write16(os, (int)(tn[i].x * Tables.MULT));
			write16(os, (int)(tn[i].y * Tables.MULT));
			write16(os, (int)(tn[i].z * Tables.MULT));
		}
	}

	private void saveTexturesAsBin(String pid) throws Exception
	{
		OutputStream os = new BufferedOutputStream(new FileOutputStream(pid+ "_tex.o3d"));
		write8(os, tm.getChildCount(texts) - 1);
		for (int i = 0; i < tm.getChildCount(texts); i++)
		{
			Vector<Color> pal = new Vector<Color>();
			short[][][] tx = TexturedTriangle3D.getTexture(((DefaultMutableTreeNode)tm.getChild(texts, i)).getUserObject().toString());
			int[][] pix = new int[txTrans(tx.length, tx.length)][txTrans(tx[0].length, tx[0].length)];
			int trans = 255;
			int rsum = 0, gsum = 0, bsum = 0;
			for (int a = 0; a < pix.length; a++)
			{
				int aa = txUntrans(a, tx.length);
				for (int b = 0; b < pix[0].length; b++)
				{
					int bb = txUntrans(b, tx[0].length);
					rsum += tx[aa][bb][0];
					gsum += tx[aa][bb][1];
					bsum += tx[aa][bb][2];
					Color cc = new Color(tx[aa][bb][0], tx[aa][bb][1],tx[aa][bb][2]);
					int pos = pal.indexOf(cc);
					if (pos < 0)
					{
						pos = pal.size();
						pal.addElement(cc);
						if (tx[aa][bb][0] == tx[aa][bb][2] && tx[aa][bb][0] - tx[aa][bb][1] >= 224)
							trans = pos;
					}
					pix[a][b] = pos;
				}
			}
			rsum /= pix.length * pix[0].length;
			gsum /= pix.length * pix[0].length;
			bsum /= pix.length * pix[0].length;
			write8(os, trans);
			write8(os, rsum);
			write8(os, gsum);
			write8(os, bsum);
			write8(os, pal.size() - 1);
			for (int a = 0; a < pal.size(); a++)
			{
				Color cc = pal.elementAt(a);
				write8(os, cc.getRed());
				write8(os, cc.getGreen());
				write8(os, cc.getBlue());
			}
			for (int a = 0; a < pal.size(); a++)
			{
				Color cc = pal.elementAt(a);
				write16(os, GPCOL(cc));
			}
			write8(os, pix[0].length - 1);
			write8(os, pix.length - 1);
			for (int a = 0; a < pix.length; a++)
			{
				for (int b = 0; b < pix[0].length; b++)
					write8(os, pix[a][b]);
			}
		}
		os.close();
	}

	private void saveSpritesAsBin(String pid) throws Exception
	{
		OutputStream os = new BufferedOutputStream(new FileOutputStream(pid + "_spr.o3d"));
		write8(os, tm.getChildCount(sprites) - 1);
		for (int i = 0; i < tm.getChildCount(sprites); i++)
		{
			SpritePanel sp = (SpritePanel)((DefaultMutableTreeNode)tm.getChild(sprites, i)).getUserObject();
			Rectangle r = sp.getRectangle();
			write8(os, r.x);
			write8(os, r.y);
			write8(os, r.width - 1);
			write8(os, r.height - 1);
			write8(os, getTextureIndex(sp.getPath()));
		}
		os.flush();
		os.close();
	}

	public void mouseClicked(MouseEvent e)
	{
		int x = e.getX(), y = e.getY();
		Dimension d = surface.getSize();
		if (x < 0 || x >= d.width || y < 0 || y >= d.height)
			return;
		Triangle3D tt = surface.tmap[y * d.width + x];
		if (tt == null)
			return;

		Triangle3D t[] = tt.origin.obj.getTriangles();
		if (e.getButton() == MouseEvent.BUTTON2)
		{
			int alpha = t[0].alpha > 64 ? t[0].alpha - 64 : 255;
			for (int i = 0; i < t.length; i++)
				t[i].alpha = alpha;
		}
		else if (e.getButton() == MouseEvent.BUTTON1)
		{
			if (tt instanceof ColoredTriangle3D)
				((ColoredTriangle3D)tt.origin).overloadColor(curcol);
		}
		else
		{
			if (tt instanceof ColoredTriangle3D)
			{
				Triangle3D[] tris = tt.origin.obj.getTriangles();
				Color cc = ((ColoredTriangle3D)tt).getColor();
				for (int i = 0; i < tris.length; i++)
				{
					if (tris[i] instanceof ColoredTriangle3D)
					{
						ColoredTriangle3D ct = (ColoredTriangle3D)tris[i];
						if (ct.getColor().equals(cc))
							ct.overloadColor(curcol);
					}
				}
			}
		}
		surface.dopaint();
	}

	private transient JPopupMenu curmenu = null;

	public void show(JPopupMenu menu, Component c, int x, int y)
	{
		menu.show(c, x, y);
		curmenu = menu;
	}

	public void mousePressed(MouseEvent e)
	{
		if (e.getSource() == surface)
		{
			xi = e.getX();
			yi = e.getY();
			return;
		}
		if (e.getButton() != MouseEvent.BUTTON3)
			return;
		TreePath p = tree.getPathForLocation(e.getX(), e.getY());
		if (p == null)
			return;
		Object o = p.getLastPathComponent();
		if (o == root)
			show(prjmenu, tree, e.getX(), e.getY());
		if (o == objects)
			show(objmenu, tree, e.getX(), e.getY());
		else if (o == scenes)
			show(scenemenu, tree, e.getX(), e.getY());
		else if (o == maps)
			show(mapmenu, tree, e.getX(), e.getY());
		else if (o == sprites)
			show(sprmenu, tree, e.getX(), e.getY());
		else if (o == chars)
			show(charmenu, tree, e.getX(), e.getY());
		else if (o == texts)
			show(texmenu, tree, e.getX(), e.getY());
		else
		{
			tree.getSelectionModel().setSelectionPath(p);
			if (p.getPathCount() < 2)
				return;
			Object parent = p.getPathComponent(p.getPathCount() - 2);
			o = ((DefaultMutableTreeNode)o).getUserObject();
			if (parent == objects)
				show(o_menu, tree, e.getX(), e.getY());
			else if (parent == scenes)
				show(sc_menu, tree, e.getX(), e.getY());
			else if (parent == sprites)
				show(sp_menu, tree, e.getX(), e.getY());
			else if (parent == maps)
				show(m_menu, tree, e.getX(), e.getY());
			else if (parent == chars)
				show(c_menu, tree, e.getX(), e.getY());
			else if (parent == texts)
				show(t_menu, tree, e.getX(), e.getY());
		}
	}

	public void mouseReleased(MouseEvent e)
	{
	}

	public void mouseEntered(MouseEvent e)
	{
	}

	public void mouseExited(MouseEvent e)
	{
	}

	public void mouseDragged(MouseEvent e)
	{
		int x = e.getX();
		int y = e.getY();
		rx += y - yi;
		ry += xi - x;
		rot.x = (float)(((Math.PI * 2) / 512) * rx);
		rot.y = (float)(((Math.PI * 2) / 512) * ry);
		rot.z = (float)(((Math.PI * 2) / 512) * rz);
		surface.dopaint();
		xi = x;
		yi = y;
	}

	public void mouseMoved(MouseEvent e)
	{
	}

	public void mouseWheelMoved(MouseWheelEvent e)
	{
		if (obj instanceof MD2Object3DLoader)
		{
			if (e.getScrollType() == MouseWheelEvent.WHEEL_UNIT_SCROLL)
			{
				if (e.getWheelRotation() > 0)
					((MD2Object3DLoader)obj).nextFrame();
				else
					((MD2Object3DLoader)obj).previousFrame();
				surface.dopaint();
			}
		}
	}

	public void setVisible(boolean v)
	{
		if (!v)
			System.exit(0);
		super.setVisible(v);
	}

	public void valueChanged(TreeSelectionEvent e)
	{
		if (obj != null)
			scene.removeObject(obj);
		setObject(null);
		if (cmd != null)
			cmdCont.remove(cmd);
		cmd = null;
		TreePath p = e.getNewLeadSelectionPath();
		if (p == null || p.getPathCount() < 3)
		{
			refresh();
			return;
		}
		DefaultMutableTreeNode n = (DefaultMutableTreeNode) p.getLastPathComponent();
		Object o = n.getUserObject();
		if (o instanceof ProjectPanel)
		{
			ProjectPanel pan = (ProjectPanel)o;
			cmdCont.add(cmd = pan);
		}
		else if (o instanceof ObjectPanel)
		{
			ObjectPanel pan = (ObjectPanel)o;
			setObject(pan.getObject());
			scene.addObject(obj, new Position3D(new Point3D(0, 0, 0), rot = new Rotation3D(0, 0, 0), pan.getZoom()));
			cmdCont.add(cmd = pan);
		}
		else if (o instanceof ScenePanel)
		{
			setObject(((ScenePanel)o).getScene());
			scene.addObject(obj, new Position3D(new Point3D(0, 0, 0),
					rot = new Rotation3D(0, 0, 0), 1.0f));
			cmdCont.add(cmd = (ScenePanel)o);
		}
		else if (o instanceof MapPanel)
		{
			MapPanel pan = (MapPanel)o;
			setObject(pan.getMap());
			scene.addObject(obj, new Position3D(new Point3D(0, 0, 0), rot = new Rotation3D(0, 0, 0), 0.1f));
			cmdCont.add(cmd = pan);
		}
		else if (o instanceof SubPanel)
		{
			DefaultMutableTreeNode n2 = (DefaultMutableTreeNode)p.getPathComponent(2);
			Object o2 = n2.getUserObject();
			setObject(((ScenePanel)o2).getScene());
			scene.addObject(obj, new Position3D(new Point3D(0, 0, 0), rot = new Rotation3D(0, 0, 0), 1.0f));
			cmdCont.add(cmd = (SubPanel)o);
		}
		else if (o instanceof SpritePanel)
		{
			cmdCont.add(cmd = (SpritePanel)o);
		}
		refresh();
	}

	public void paint(Graphics g)
	{
		super.paint(g);
		surface.dopaint();
		if (curmenu != null)
			curmenu.repaint(0);
	}

	public void refresh()
	{
		this.dispatchEvent(new ComponentEvent(surface,ComponentEvent.COMPONENT_RESIZED));
		cmdCont.repaint(0);
		surface.dopaint();
	}

	public static void main(String[] args)
	{
		new Export3D();
	}
}
