import j3d.basic.*;
import j3d.basic.colored.*;
import java.io.*;

public class LevelMap extends FractalMap
{
	public LevelMap(int w,int h)
	{
		super(w,h,0,16,16);
	}

	protected void alloc(int tcount)
	{
		triangles = BasicColoredObject3D.alloc(tcount);
	}

	protected void setTriangle(int idx,int a,int b,int c)
	{
		BasicColoredObject3D.setTriangle(this,idx,a,b,c);
	}

	public static MapPanel loadMap(File f) throws Exception
	{
		LineNumberReader lnr = new LineNumberReader(new FileReader(f));
		String line,name=null;
		int w=0,h=0;
		while ((line = lnr.readLine())!=null)
		{
			if (line.equals("[WIDTH]"))
			{
				w = Integer.valueOf(lnr.readLine()).intValue();
			}
			else if (line.equals("[HEIGHT]"))
			{
				h = Integer.valueOf(lnr.readLine()).intValue();
			}
			else if (line.equals("[NAME]"))
			{
				name = lnr.readLine();
			}
		}
		return new MapPanel(name,new LevelMap(w,h));
	}
}
