import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import j3d.*;

public class MonPanel extends JPanel
{
	static final long serialVersionUID = 1;

	Dimension d = null;
	Image viewimg;
	Graphics gg;
	int[] img = null;
	float zbuf[] = null;
	MemoryImageSource src = null;
	Image image;
	Scene3D scene;
	View3D view;
	Position3D camera;
	Light3D[] lights;
	Triangle3D[] tmap;
	Object3D obj;
	float proj,maxz;

	public MonPanel(Scene3D scene,View3D view,Position3D camera,Light3D[] lights,float proj,float maxz)
	{
		enableEvents(-1);
		setOpaque(true);
		this.scene = scene;
		this.view = view;
		this.camera = camera;
		this.lights = lights;
		tmap = null;
		this.proj = proj;
		this.maxz = maxz;
	}

	public void processEvent(AWTEvent e)
	{
		super.processEvent(e);
/*
if (!(e instanceof MouseEvent))
System.err.println(e);
*/
		if (e.getID()==ComponentEvent.COMPONENT_RESIZED && e.getSource()==this)
			dopaint();
	}

	public void paint(Graphics g)
	{
		dopaint();
	}

	public void dopaint()
	{
		Graphics g = getGraphics();
		if (g==null)
			return;
		Dimension dd = getSize();
		if (dd.width<=0)
			return;
		if (d==null||dd.width!=d.width||dd.height!=d.height)
		{
			d = getSize();
//System.err.println(d);
			img = new int[d.width*d.height];
			zbuf = new float[img.length];
			tmap = new Triangle3D[img.length];
			src = new MemoryImageSource(d.width,d.height,img,0,d.width);
			src.setFullBufferUpdates(true);
			src.setAnimated(true);
			image = createImage(src);
			viewimg = createImage(d.width,d.height);
			gg = viewimg.getGraphics();
			System.gc();
		}
		if (obj==null && Export3D.tree!=null)
		{
			javax.swing.tree.TreePath p = Export3D.tree.getSelectionModel().getLeadSelectionPath();
			gg.setColor(Color.darkGray);
			gg.fillRect(0,0,d.width-1,d.height-1);
			if (p!=null && p.getPathCount()>2 && p.getPathComponent(1)==Export3D.texts)
			{
				try
				{
					gg.drawImage(TexturedTriangle3D.getImage(p.getLastPathComponent().toString()),0,0,null);
				}
				catch(Exception e)
				{
					e.printStackTrace();
				}
			}
		}
		else
		{
			view.render(img,zbuf,tmap,new Rectangle(d.width/2,d.height/2,d.width,d.height),scene,camera,512,maxz,lights);
			src.newPixels();
			gg.drawImage(image,0,0,null);
		}
		g.drawImage(viewimg,0,0,null);
	}
}

