import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import j3d.*;

public class ObjectPanel extends JPanel implements ActionListener
{
	static final long serialVersionUID = 1;

	Object3D obj;
	JTextField id,zoom;
	JLabel bbox,path;
	float z;
	boolean center = false;

	ObjectPanel(Object3D o)
	{
		this(Export3D.idFromPath(o.toString()),o,1.0f,false);
	}

	ObjectPanel(String sid,Object3D o,float z,boolean center)
	{
		obj = o;
		setLayout(new BorderLayout(8,8));
		JPanel p0 = new JPanel(new GridLayout(5,1));
		add(p0,BorderLayout.WEST);
		JPanel p1 = new JPanel(new GridLayout(5,1));
		add(p1,BorderLayout.EAST);
		p0.add(new JLabel("ID"));
		p1.add(id = new JTextField());
		id.setText(sid);
		p0.add(new JLabel("Path"));
		p1.add(path = new JLabel());
		path.setText(o.toString());
		p0.add(new JLabel("Zoom"));
		p1.add(zoom = new JTextField(String.valueOf(z)));
		zoom.addActionListener(this);
		zoom.setActionCommand("ZOOM");
		this.z = z;
		p0.add(new JLabel("Bounding box"));
		p1.add(bbox = new JLabel());
		Point3D[] bb = obj.getBoundingBox();
		bbox.setText("min="+bb[0].x+","+bb[0].y+","+bb[0].z+" max="+bb[1].x+","+bb[1].y+","+bb[1].z);
		JButton b = new JButton("Center");
		p0.add(b);
		b.addActionListener(this);
		b.setActionCommand("CENTER");
		JLabel l;
		p1.add(l = new JLabel());
		l.setText(o instanceof Scene3D?	"v="+((Scene3D)o).getVCount()+" t="+((Scene3D)o).getTCount():
										"v="+o.getVertices().length+" t="+o.getTriangles().length);
		if (center)
			doCenter();
	}

	Object3D getObject()
	{
		return obj;
	}

	public float getZoom()
	{
		return z;
	}

	public boolean isCenter()
	{
		return center;
	}

	public String getPath()
	{
		return path.getText();
	}

	public String toString()
	{
		return id.getText();
	}

	public void actionPerformed(ActionEvent e)
	{
		String c = e.getActionCommand();
		if (c.equals("ZOOM"))
		{
			z = Export3D.check(zoom,z);
			Export3D.refreshNode();
		}
		if (c.equals("CENTER"))
		{
			doCenter();
			Export3D.refreshNode();
		}
	}

	public void doCenter()
	{
		obj.center();
		Point3D[] bb = obj.getBoundingBox();
		bbox.setText("min="+bb[0].x+","+bb[0].y+","+bb[0].z+" max="+bb[1].x+","+bb[1].y+","+bb[1].z);
		center = true;
	}
}

