package j3d;

import java.awt.Point;

public abstract class AbstractTransformableObject3D implements Object3D,Transformable3D {

  public void transform(Object3D o,Matrix3D cur,Position3D pos,Point3D[] v,Triangle3D[] t,Vector3D[] vnorm,Vector3D[] tnorm,Point dVT) {
    Point3D[] ov = getVertices();
    Vector3D[] on = getVNormals();
    Matrix3D m = pos.getTransMatrix();
    m = m.multiply(cur);
    int l = ov.length, dV = dVT.x;
    for (int i=0;i<l;i++) {
        m.multiply(ov[i],v[dVT.x]);
        m.multiply(on[i],vnorm[dVT.x]);
        vnorm[dVT.x++].normalize();
    }
    Triangle3D[] ot = getTriangles();
    l = ot.length;
    on = getTNormals();
    Point3D zero = new Point3D(0f,0f,0f);
    zero = m.multiply(zero);
    for (int i=0;i<l;i++)
    {
        m.multiply(on[i],tnorm[dVT.y]);
        tnorm[dVT.y].substract(zero);
        t[dVT.y++] = ot[i].copy(o,dV);
    }
  }

  public Point3D[] getBoundingBox() {
    Point3D[] v = getVertices();
    Point3D min = v==null||v.length==0?new Point3D():new Point3D(v[0].x,v[0].y,v[0].z);
    Point3D max = new Point3D(min);
    for (int i=1;v!=null&&i<v.length;i++) {
        min.x = Math.min(min.x,v[i].x);
        min.y = Math.min(min.y,v[i].y);
        min.z = Math.min(min.z,v[i].z);
        max.x = Math.max(max.x,v[i].x);
        max.y = Math.max(max.y,v[i].y);
        max.z = Math.max(max.z,v[i].z);
    }
    return new Point3D[] {min,max};
  }

  public Object3D copy()
  {
	return new j3d.loader.DefaultObject3D(toString(),getVertices(),getTriangles());
  }
}
