package j3d;

public class Point3D extends Vector3D {

  public Point3D(float x, float y, float z) {
    super(x,y,z);
  }

  public Point3D() { this(0f,0f,0f); }

  public Point3D(Vector3D v) {
    this(v.x,v.y,v.z);
  }

  public Matrix3D getTransMatrix() {
    return new Matrix3D(Matrix3D.TRANS,x,y,z);
  }

  public boolean equals(Object o) {
    if (!(o instanceof Point3D)) return false;
    Point3D p = (Point3D)o;
    return (p.x==x) && (p.y==y) && (p.z==z);
  }

  public float dist(Point3D p) {
    return (float)Math.sqrt(((p.x-x)*(p.x-x))+((p.y-y)*(p.y-y))+((p.z-z)*(p.z-z)));
  }
}
