package j3d;

import java.awt.Rectangle;

public class Sprite3D
{
	public Rectangle def;
	public short[][][] tex;
	public int trans;

	private static Point3D zero = new Point3D(0f,0f,0f);
	public transient Point3D center = new Point3D();

	public Sprite3D(int x,int y,int w,int h,short[][][] tex)
	{
		this(x,y,w,h,tex,0xff000000);
	}

	public Sprite3D(int x,int y,int w,int h,short[][][] tex,int trans)
	{
		def = new Rectangle(x,y,w,h);
		this.tex = tex;
		this.trans = trans;
	}

	public void transform(Matrix3D cur,Position3D pos)
	{
		Matrix3D m = pos.getTransMatrix();
		m = m.multiply(cur);
	    m.multiply(zero,center);
	}

	public void paint(int[] img,float[] zbuf,Rectangle r,float proj)
	{
		float x0 = ((center.x-(def.width/2))*proj)/center.z;
		float x1 = ((center.x+(def.width/2))*proj)/center.z;
		float y0 = ((center.y-(def.height/2))*proj)/center.z;
		float y1 = ((center.y+(def.height/2))*proj)/center.z;
		int w = (int)Math.abs(x1-x0);
		int h = (int)Math.abs(y1-y0);
		int x = r.x+(int)Math.min(x0,x1);
		int y = r.y+(int)Math.min(y0,y1);
		float dx = ((float)def.width)/w;
		float dy = ((float)def.height)/h;
		for (int i=0;i<w;i++)
		{
			if (x+i<0 || x+i>=r.width)
				continue;
			int xx = def.x+(int)(i*dx);
			for (int j=0;j<h;j++)
			{
				if (y+j<0 || y+j>=r.height)
					continue;
				int yy = def.y+(int)(j*dy);
				int k = (y+j)*r.width+x+i;
				if (center.z>zbuf[k])
				{
					int pix = (0xff<<24) | (tex[yy][xx][0]<<16) | (tex[yy][xx][1]<<8) | tex[yy][xx][2];
					if (pix!=trans)
					{
						img[k] = pix;
						zbuf[k] = center.z;
					}
				}
			}
		}
	}
}
