package j3d;

public abstract class Vector3D implements Transformer3D {

  public float x,y,z;

  public Vector3D(float x, float y, float z) {
    this.x = x;
    this.y = y;
    this.z = z;
  }

  public float dotProduct(Vector3D v) {
    return v.x*x+v.y*y+v.z*z;
  }

  public void normalize() {
    float l = length();
    x /= l;
    y /= l;
    z /= l;
  }

  public void normalize(float l) {
    x /= l;
    y /= l;
    z /= l;
  }

  public void substract(Vector3D v) {
    x -= v.x;
    y -= v.y;
    z -= v.z;
  }

  public void add(Vector3D v) {
    x += v.x;
    y += v.y;
    z += v.z;
  }

  public float length() {
    return (float)Math.sqrt(x*x+y*y+z*z);
  }

  public String toString()
  {
	  return x+","+y+","+z;
  }
}
