package j3d.basic;

import j3d.*;

public abstract class BasicObject3D extends AbstractTransformableObject3D {

  protected Point3D[] vertices;
  protected Triangle3D[] triangles;
  protected Vector3D[] vnormals;
  protected Vector3D[] tnormals;

  public Point3D[] getVertices() { return vertices; }

  public Triangle3D[] getTriangles() { return triangles; }

  public Vector3D[] getVNormals() { return vnormals; }

  public Vector3D[] getTNormals() { return tnormals; }

  protected abstract void setTriangle(int idx,int a,int b,int c);

  protected abstract void alloc(int tcount);

  public void setAlpha(int alpha) {
    for (int i=0;i<triangles.length;i++) triangles[i].alpha = alpha;
  }

  public void initNormals() {
    vnormals = new Vector3D[vertices.length];
    tnormals = new Vector3D[triangles.length];
    for (int i=0;i<vertices.length;i++) vnormals[i] = new Point3D();
    for (int i=0;i<triangles.length;i++) {
        Triangle3D tt = triangles[i];
        Point3D vn = new Point3D();
        tt.getNormal(vn);
        vnormals[tt.a].add(vn);
        vnormals[tt.b].add(vn);
        vnormals[tt.c].add(vn);
        tnormals[i] = vn;
    }
  }
  
  public void center()
  {
	Point3D[] bb = getBoundingBox();
	float dx = (bb[0].x + bb[1].x)/2;
	float dy = (bb[0].y + bb[1].y)/2;
	float dz = (bb[0].z + bb[1].z)/2;
	Point3D[] v = getVertices();
	for (int i=0;i<v.length;i++)
	{
		v[i].x-=dx;
		v[i].y-=dy;
		v[i].z-=dz;
	}
  }
}
