package j3d.basic;

import j3d.*;

public abstract class Cylinder extends BasicObject3D {

  public Cylinder(float radius,float height,int sections) {
    vertices = new Point3D[sections*2+2];
    alloc(sections*4);

    float h = height/2, theta = (float)(Math.PI*2)/sections;

    vertices[0] = new Point3D(0,-h,0);
    vertices[1] = new Point3D(0,h,0);
    for (int i=0;i<sections;i++) {
        vertices[i+2] = new Point3D(radius*(float)Math.cos(i*theta),-h,radius*(float)Math.sin(i*theta));
        vertices[i+sections+2] = new Point3D(radius*(float)Math.cos(i*theta),h,radius*(float)Math.sin(i*theta));
    }

    for (int i=0;i<sections;i++) {
        setTriangle(i,0,(i+1==sections?2:i+3),i+2);
        setTriangle(i+sections,1,i+sections+2,(i+1==sections?sections+2:i+sections+3));
        setTriangle(i+sections*2,i+2,(i+1==sections?sections+2:i+sections+3),i+sections+2);
        setTriangle(i+sections*3,(i+1==sections?2:i+3),(i+1==sections?sections+2:i+sections+3),i+2);
    }

    initNormals();
  }
}
