package j3d.basic;

import j3d.*;

public abstract class Sphere extends BasicObject3D {

  public Sphere(float radius,int sections) {
    int s2 = sections*2;
    int sep = (int)(radius/s2);
    vertices = new Point3D[s2*s2+2];
    alloc(2*s2*(s2-1)+s2*2);

    float theta = (float)(Math.PI*2)/s2;
    vertices[0] = new Point3D(0,-radius-sep,0);
    vertices[1] = new Point3D(0,radius+sep,0);
    for (int i=0;i<sections;i++) {
        float d = -radius+((i+1)*radius/sections);
        for (int j=0;j<s2;j++) {
             float r = (float)Math.sqrt(radius*radius-d*d);
             Point3D p = new Point3D(r*(float)Math.cos(j*theta),d-sep,r*(float)Math.sin(j*theta));
             vertices[i*s2+j+2] = p;
             vertices[vertices.length-((i+1)*s2)+j] = new Point3D(p.x,-p.y,p.z);
        }
    }

    // Cones
    int nbt = 0;
    for (int i=0;i<s2;i++) {
        // bottom
        setTriangle(nbt++,0,(i+1==s2?2:i+3),i+2);
        // top
        setTriangle(nbt++,1,vertices.length-s2+i,(i+1==s2?vertices.length-s2:vertices.length-s2+i+1));
    }
    // Cylinders
    for (int i=0;i<s2-1;i++) {
        int di = i*s2+2;
        for (int j=0;j<s2;j++) {
            setTriangle(nbt++,di+j,(j+1==s2?di+s2:di+j+s2+1),di+j+s2);
            setTriangle(nbt++,(j+1==s2?di:di+j+1),(j+1==s2?di+s2:di+j+s2+1),di+j);
        }
    }

    initNormals();
  }
}
