package j3d.basic.colored;

import j3d.basic.*;
import java.awt.Color;

public class ColoredBox extends Box {

  private Color color;

  public ColoredBox(float width,float height,float depth,Color color) {
    super(width,height,depth);
    setColor(color);
  }

  protected void alloc(int tcount) {
    triangles = BasicColoredObject3D.alloc(tcount);
  }

  protected void setTriangle(int idx,int a,int b,int c) {
    BasicColoredObject3D.setTriangle(this,idx,a,b,c);
  }

  public void setColor(Color color) {
    this.color = color;
    BasicColoredObject3D.setColor(triangles,color);
  }

  public String toString() {
    return "basic ColoredBox "+color.getRed()+" "+color.getGreen()+" "+color.getBlue()
          +" "+(int)(vertices[0].x*2)+" "+(int)(vertices[0].y*2)+" "+(int)(vertices[0].z*2);
  }
}
