package j3d.basic.colored;

import j3d.basic.*;
import java.awt.Color;

public class ColoredFractalMap extends FractalMap {

  private Color color;

  public ColoredFractalMap(int size,int smooth,Color color) {
    super(size,smooth);
    setColor(color);
  }

  public ColoredFractalMap(int w,int h,int smooth,int my, int dy, int seed, boolean rot, Color color) {
    super(w,h,smooth,my,dy,seed,rot);
    setColor(color);
  }

  protected void alloc(int tcount) {
    triangles = BasicColoredObject3D.alloc(tcount);
  }

  protected void setTriangle(int idx,int a,int b,int c) {
    BasicColoredObject3D.setTriangle(this,idx,a,b,c);
  }

  public void setColor(Color color) {
    this.color = color;
    BasicColoredObject3D.setColor(triangles,color);
  }

  public String toString() {
    return "basic ColoredFractalMap "+color.getRed()+" "+color.getGreen()+" "+color.getBlue()
          +" "+m_w+" "+m_h+" "+m_smooth+" "+m_my+" "+m_dy+" "+m_seed+" "+(m_rot?1:0);
  }
}
