package j3d.basic.textured;

import j3d.basic.*;
import java.awt.Image;

public class TexturedBox extends Box {
  public TexturedBox(float width,float height,float depth,Image texture,boolean mode) {
    super(width,height,depth);
    setTexture(texture,mode);
  }

  public TexturedBox(float width,float height,float depth,Image[] texture,boolean mode) {
    super(width,height,depth);
    BasicTexturedObject3D.setTexture(this.getTriangles(),texture);
  }

  public TexturedBox(float width,float height,float depth) {
    super(width,height,depth);
  }

  protected void alloc(int tcount) {
    triangles = BasicTexturedObject3D.alloc(tcount);
  }

  protected void setTriangle(int idx,int a,int b,int c) {
    BasicTexturedObject3D.setTriangle(this,idx,a,b,c);
  }

  public void setTexture(Image texture,boolean mode) {
    if (mode) BasicTexturedObject3D.setTexture(triangles,texture);
    else BasicTexturedObject3D.setTexture(this,texture);
  }

  public String toString() {
    return "basic TexturedBox"
          +" "+(int)(vertices[0].x*2)+" "+(int)(vertices[0].y*2)+" "+(int)(vertices[0].z*2);
  }
}
