package j3d.basic.textured;

import j3d.basic.*;
import java.awt.Image;

public class TexturedMap extends Map
{
	public TexturedMap(int w,int h,Image texture,boolean mode)
	{
		super(w,h);
		init();
		setTexture(texture,mode);
	}

	protected void alloc(int tcount)
	{
		triangles = BasicTexturedObject3D.alloc(tcount);
	}

	protected void setTriangle(int idx,int a,int b,int c)
	{
		BasicTexturedObject3D.setTriangle(this,idx,a,b,c);
	}

	public void setTexture(Image texture,boolean mode)
	{
    	if (mode)
			BasicTexturedObject3D.setTexture(triangles,texture);
    	else
			BasicTexturedObject3D.setTexture(this,texture);
	}

	public String toString()
	{
    	return "basic TexturedMap "+m_w+" "+m_h;
	}
}
