package j3d.basic.textured;

import java.awt.Point;
import java.io.LineNumberReader;

import j3d.TexturedTriangle3D;
import j3d.basic.Track;

public class TexturedTrack extends Track
{
	private String tpath;
	
	public TexturedTrack(int div,String tpath) throws Exception
	{
		this(div,tpath,null);
	}

	public TexturedTrack(int div,String tpath,LineNumberReader lnr) throws Exception
	{
		super(div,lnr);
		this.tpath = tpath;
		setTexture(TexturedTriangle3D.getTexture(tpath));
	}

	public void reset(int div,String tpath) throws Exception
	{
		reset(div);
		this.tpath = tpath;
		setTexture(TexturedTriangle3D.getTexture(tpath));
	}

	protected void alloc(int tcount)
	{
		triangles = BasicTexturedObject3D.alloc(tcount);
	}

	protected void setTriangle(int idx,int a,int b,int c)
	{
		BasicTexturedObject3D.setTriangle(this,idx,a,b,c);
	}

	public void setTexture(short[][][] tex)
	{
		TexturedTriangle3D[] t = (TexturedTriangle3D[])getTriangles();
		int x,y,w=24,h=49,i=0;
		while (i<t.length)
		{
			for (int j=0;j<7;j++)
			{
				// side 1
				int z = data[i/14][j];
				x = z*(w+1);
				y = 0;
				t[i].texture = tex;
				t[i].tp[0] = new Point(x+1,y+h-1);
				t[i].tp[1] = new Point(x+1,y+1);
				t[i].tp[2] = new Point(x+w-1,y+h-1);
				i+=1;
				t[i].texture = tex;
				t[i].tp[0] = new Point(x+w-1,y+h-1);
				t[i].tp[1] = new Point(x+1,y+1);
				t[i].tp[2] = new Point(x+w-1,y+1);
				i+=1;
			}
		}
	}

	public String toString()
	{
		return "basic TexturedTrack "+traj.length+" "+tpath;
	}
}
