package j3d.loader;

import java.io.*;
import java.util.*;
import java.awt.*;
import j3d.*;

public class ASCObject3DLoader implements Object3DLoader
{
	private String name;

	public ASCObject3DLoader()
	{
	}

	public Object3D loadObject(String fileName)
	{
		return loadObject(new File(fileName));
	}

	public Object3D loadObject(File file)
	{
		try
		{
			name = file.getAbsolutePath();
			return loadObject(new FileInputStream(file));
		}
		catch(Exception e) { e.printStackTrace(); }
    	return null;
	}

	private float FloatValue(String s)
	{
		if (s.indexOf('e')>=0)
			return 0.0f;
		return Float.valueOf(s).floatValue();
	}

	public Object3D loadObject(InputStream is) throws IOException
	{
		LineNumberReader r = new LineNumberReader(new InputStreamReader(is));
		Vector<Vector<Object>> faces = new Vector<Vector<Object>>();
		Vector<Point3D> vertices = new Vector<Point3D> ();
		String line;

		line = r.readLine();
		while (line!=null)
		{
			int delta = vertices.size();
			while(!line.startsWith("Vertex"))
				line = r.readLine();
			line = r.readLine();
			while(line.startsWith("Vertex"))
			{
				int px = line.indexOf("X:");
				int py = line.indexOf("Y:");
				int pz = line.indexOf("Z:");
				Point3D p = new Point3D(FloatValue(line.substring(px+2,py-1)),
						FloatValue(line.substring(py+2,pz-1)),
						FloatValue(line.substring(pz+2)));
				vertices.addElement(p);
				line = r.readLine();
			}
			line = r.readLine();
			while(line!=null && !line.startsWith("Named object"))
			{
				if (line.startsWith("Face "))
				{
					Vector<Object> v = new Vector<Object>();
					int pa = line.indexOf("A:");
					int pb = line.indexOf("B:");
					int pc = line.indexOf("C:");
					int pz = line.indexOf("AB:");
					v.addElement(new Integer(Integer.valueOf(line.substring(pc+2,pz-1)).intValue()+delta));
					v.addElement(new Integer(Integer.valueOf(line.substring(pb+2,pc-1)).intValue()+delta));
					v.addElement(new Integer(Integer.valueOf(line.substring(pa+2,pb-1)).intValue()+delta));
					faces.addElement(v);
					line = r.readLine();
					if (line==null)
						break;
					else if (line.startsWith("Face "))
						continue;
					else if (line.startsWith("Material:"))
					{
						String s = line.substring(10);
						if (s.charAt(0)!='r')
							continue;
						int p0 = s.indexOf('g');
						int red = Integer.valueOf(s.substring(1,p0)).intValue();
						int p1 = s.indexOf('b');
						int green = Integer.valueOf(s.substring(p0+1,p1)).intValue();
						p0 = s.indexOf('a');
						int blue = Integer.valueOf(s.substring(p1+1,p0)).intValue();
						v.addElement(new Color(red,green,blue));
					}
				}
				line = r.readLine();
			}
		}
		r.close();
		return new DefaultObject3D(name,vertices,faces);
	}

	public Object3D loadObject(Object source)
	{
		return null;
	}
}
