package j3d.loader;

import j3d.*;
import j3d.basic.*;
import j3d.basic.colored.*;
import j3d.basic.textured.*;
import java.util.*;
import java.awt.*;

public class DefaultObject3D extends BasicObject3D {

  public static Color[] palet = {Color.black,Color.blue,Color.cyan,Color.gray,Color.green,Color.magenta,Color.orange,Color.pink};

  private Object attrib = null;

  private String name;

  public DefaultObject3D(String name,Point3D[] v,Triangle3D[] t) {
    vertices = new Point3D[v.length];
	for (int i=0;i<v.length;i++)
		vertices[i] = new Point3D(v[i].x,v[i].y,v[i].z);
    triangles = new Triangle3D[t.length];
	for (int i=0;i<t.length;i++)
		triangles[i] = t[i].copy(this);
    initNormals();
  }

  public DefaultObject3D(String name,Vector v,Vector f) {
    this.name = name;
    vertices = new Point3D[v.size()];
    alloc(f.size());
    for (int i=0;i<vertices.length;i++) vertices[i] = (Point3D)v.elementAt(i);
    for (int i=0;i<triangles.length;i++) {
        Vector vf = (Vector)f.elementAt(i);
        Object type = (vf.size()>3)?vf.elementAt(3):Color.blue;
        if (type instanceof Integer)
           attrib = palet[((Integer)type).intValue()%8];
        else attrib = type;
        setTriangle(i,((Integer)vf.elementAt(0)).intValue(),((Integer)vf.elementAt(1)).intValue(),((Integer)vf.elementAt(2)).intValue());
    }
    initNormals();
  }

  public DefaultObject3D(String name,ArrayList<Point3D> v,ArrayList<ArrayList<Object>> f) {
	    this.name = name;
	    vertices = new Point3D[v.size()];
	    alloc(f.size());
	    for (int i=0;i<vertices.length;i++) vertices[i] = v.get(i);
	    for (int i=0;i<triangles.length;i++) {
	    	ArrayList<Object> vf = f.get(i);
	        Object type = (vf.size()>3)?vf.get(3):Color.blue;
	        if (type instanceof Integer)
	           attrib = palet[((Integer)type).intValue()%8];
	        else attrib = type;
	        setTriangle(i,((Integer)vf.get(0)).intValue(),((Integer)vf.get(1)).intValue(),((Integer)vf.get(2)).intValue());
	    }
	    initNormals();
	  }

  protected void alloc(int tcount) {
    triangles = new Triangle3D[tcount];
  }

  protected void setTriangle(int idx,int a,int b,int c) {
    if (attrib instanceof Color) {
       BasicColoredObject3D.setTriangle(this,idx,a,b,c);
       ((ColoredTriangle3D)triangles[idx]).setColor((Color)attrib);
    } else {
       BasicTexturedObject3D.setTriangle(this,idx,a,b,c);
       ArrayList v = (ArrayList)attrib;
       TexturedTriangle3D t = (TexturedTriangle3D)triangles[idx];
       t.setTexture((short[][][])v.get(0));
       int i=1;
       for (int j=0;j<3;j++) {
           int x = Math.min(((Integer)v.get(i++)).intValue(),t.getTexture()[0].length-1);
           int y = Math.min(((Integer)v.get(i++)).intValue(),t.getTexture().length-1);
           t.tp[j] = new Point(x,y);
       }
    }
  }

  public String toString()
  {
    return name;
  }
}
