package j3d.loader;

import j3d.Object3D;
import j3d.Point3D;

import java.awt.Color;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Vector;

public class UNAIObject3DLoader
{
	private String name;
	private byte[] binlwo;
	private int offset;
	
	public UNAIObject3DLoader()
	{
	}
	
	public Object3D loadObject(String fileName)
	{
		return loadObject(new File(fileName));
	}
	
	public Object3D loadObject(File file)
	{
		try
		{
			name = file.getAbsolutePath();
			binlwo = new byte[(int)file.length()];
			return loadObject(new FileInputStream(file));
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		return null;
	}
	
	private int readChar()
	{
		if (offset==binlwo.length)
			return -1;
		int b = binlwo[offset++];
		return(b<0?256:0)+b;
	}
	
	private int readInt()
	{
		int i = readChar();
		i |= (readChar()<<8);
		i |= (readChar()<<16);
		i |= (readChar()<<24);
		return i;
	}
	
	public Object3D loadObject(InputStream stream) throws IOException
	{
		stream.read(binlwo);
		offset = 0;
		int nbv = readInt();
		int nbt = readInt();
		Vector<Point3D> verts = new Vector<Point3D>(nbv);
		for (int i=0;i<nbv;i++)
			verts.addElement(new Point3D(readInt(),readInt(),readInt()));
		Vector<Vector<Object>> faces = new Vector<Vector<Object>>(nbt);
		for (int i=0;i<nbt;i++)
		{
			Vector<Object> face = new Vector<Object>();
			int j = readInt();
			face.addElement(new Integer(readInt()));
			face.addElement(new Integer(j));
			face.addElement(new Integer(readInt()));
			face.addElement(Color.blue);
			faces.addElement(face);
		}
		return new DefaultObject3D(name,verts,faces);
	}
}
